<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 01/08/14
 * Time: 12:50
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Facade;


class EmbeddedReportFacade {

    //Roda procedures necessárias para atualizar os dados do relatório de desempenho do Ger. de Unidade
    public static function runGUProcedures(){
        $result=\Scheduler\Util\ReportFunctions::runEtlPlanejadora();
        $result ? "noop" : tk_warning("Ocorreu um erro! As informações não puderam ser atualizadas.");
    }

    public static function openPopupOrRunCallable($toRun, $isPopup=true){
        //a string "false" é avaliada como true, então é preciso checar por ela também
        if($isPopup && $isPopup!=="false"){
            tk_open_window($toRun, true);
        }
        else{
            call_user_func($toRun);
        }
    }

    public static function generateResumoGerencialEmpresa(){

        //'P0M' é um intervalo nulo; a função já retorna como DATAFIM o primeiro dia do mês de DATAINICIO
        $arrayParams=\Scheduler\Util\ReportParameterFunctions::buildDateParametersFromInterval("P0M");
        $arrayParams+=\Scheduler\Util\ReportParameterFunctions::buildParametersFromAmbiente();

        \View\Geral\Report\EmbeddedReportFacade::generateReport("/gestao/resumo_gerencial_empresa", $arrayParams);
        tk_close_window("scd_param_indicador_dono_1", true);

    }

    public static function generatePainelGUMod2(){

        $arrayParams["P_CDGUNIDADE"]=\Geral\Util\Ambiente::getCdOperador();
        $arrayParams+=\Scheduler\Util\ReportParameterFunctions::buildParametersFromAmbiente();

        \View\Geral\Report\EmbeddedReportFacade::generateReport("/gestao/painel_GU_mod2", $arrayParams);

    }

    public static function generateAnaliseGerencialEmpresa(){

        //'P0M' é um intervalo nulo; a função já retorna como DATAFIM o primeiro dia do mês de DATAINICIO
        $arrayParams=\Scheduler\Util\ReportParameterFunctions::buildDateParametersFromInterval("P0M");
        $arrayParams+=\Scheduler\Util\ReportParameterFunctions::buildParametersFromAmbiente();

        \View\Geral\Report\EmbeddedReportFacade::generateReport("/gestao/analise_gerencial_empresa", $arrayParams);
        tk_close_window("scd_param_indicador_dono_2", true);

    }

    public static function generateDesempenhoGerOperacao(){

        //'P0M' é um intervalo nulo; a função já retorna como DATAFIM o primeiro dia do mês de DATAINICIO
        $arrayParams=\Scheduler\Util\ReportParameterFunctions::buildDateParametersFromInterval("P0M");
        $arrayParams+=\Scheduler\Util\ReportParameterFunctions::buildParametersFromAmbiente();
        $arrayParams["P_CDGOPERAC"]=\Geral\Util\Ambiente::getCdOperador();

        \View\Geral\Report\EmbeddedReportFacade::generateReport("/gestao/desempenho_ger_operacao", $arrayParams);
        tk_close_window("scd_param_indicador_go", true);

    }

    public static function generateAnaliseDesempenhoCompras(){

        $arrayParams=\Scheduler\Util\ReportParameterFunctions::buildParametersFromAmbiente();

        $arrayParams["P_DATA_INICIO"]=tk_get_field_value("P_DATA_INICIO");
        $arrayParams["P_DATA_FINAL"]=tk_get_field_value("P_DATA_FINAL");
        $arrayParams["P_DATA_REF_INICIAL"]=tk_get_field_value("P_DATA_REF_INICIAL");
        $arrayParams["P_DATA_REF_FINAL"]=tk_get_field_value("P_DATA_REF_FINAL");

        //$arrayParams=\Scheduler\Util\ReportParameterFunctions::buildDateParametersFromInterval("P1Y1M");
        $arrayParams["P_INDICE"]=tk_get_field_value("P_INDICE");

        \View\Geral\Report\EmbeddedReportFacade::generateReport("/gestao/analise_desempenho_compras", $arrayParams);
        tk_close_window("scd_param_indicador_des_compras", true);

    }
//    public static function generateReport($pathToReport, $parameters=null, $format=\Scheduler\Logic\Report::REPORT_FORMAT_PDF, $locale=null, $tab=null, $window=null){
//
//        if ($tab==null) $tab="scd_canvas_indicador";
//        /*  no uso original do método(injetar em scd_canvas_indicador), podem acontecer duas coisas
//         *  Ou o menu pede um popup e se torna necessário corrigir um bug do setforms,
//         *  no qual fica faltando um pedaço do tabId (o nome do menu que abriu a tab).
//         *      (quando o menu tem parâmetros o tabId absorve o nome dele)
//         *  nesse caso a variável de ambiente (que é setada com o valor do parâmetro do menu (isso é pro nome do menu
//         *      ser acessível do contexto do popup)) não é definida.
//         *  Ou o menu manda um callable, não abre um popup e aí o bug não acontece, nem a variável de ambiente é
//         *  setada.
//         *  Assim, verificando a variável MENU_NAME dá pra saber se é necessário concatenar alguma coisa
//         */
//        if ($window==null){
//            $menuNameParam=\Scheduler\Util\Macros::tk_get_menu_param(1); //nome do menu vindo do parâmetro, indisponível dentro do popup
//            $menuNameEnv=tk_get_env_var("MENU_NAME");    //nome do menu vindo da variável, só setada depois de entrar no popup
//            if(!empty($menuNameParam)){  //se o parâmetro do menu pôde ser acessado, não abriu o popup
//                $window="scd_canvas_indicador";   //o setforms corrige o bug automaticamente, então é só passar o nome da window
//                //mas o nome real da window ainda tem o nome do menu, e esse nome é utilizado
//                //num script que vai junto com o pdf injetado pra ele ficar formatado certo na tela
//                //assim é necessário criar esse nome, com o nome do menu vindo do parâmetro
//                $actualWindow=$menuNameParam."_".$window;
//            } else{  //se não, o popup abriu
//                $window=$menuNameEnv."_scd_canvas_indicador";  //o setforms não conserta o bug, então é necessário passar o nome real
//                $actualWindow=$window; //nesse caso, o nome passado e o nome real são os mesmos
//            }
//        }else{ //agora, se uma window foi passada
//            $actualWindow=$window;  //assume-se que se trata de uma situação normal, e os dois nomes são iguais
//        }
//
//        if ($parameters==null) $parameters=Array();
//        if ($locale==null) $locale=\Geral\Entities\Tradidioma::retornaIdiomaOperador();
//
//        $reportName = str_replace("_"," ",tk_get_env_var("WINDOW_NAME"));
//        if(!empty($reportName)) {
//            tk_set_window_label($reportName, $actualWindow);
//            tk_set_tab_label($reportName, $tab, $actualWindow);
//        }
//
//        //instancia um novo Report
//        $report=new \Scheduler\Logic\Report($pathToReport, $locale);
//
//        // passa os parâmetros de parameters
//        foreach ($parameters as $paramName=>$paramValue){
//            $report->addParameter($paramName, $paramValue);
//        }
//
//        //gera o relatório
//        $report->generateReport($format);
//
//        //pega o conteúdo dele como string e codifica em base64
//
//        $reportData = $report->getReportContent();
//        $reportDataEncoded = base64_encode($reportData);
//
//        //seta o src do object que será injetado
//        //se for um pdf, será injetado diretamente na página
//        if ($format===\Scheduler\Logic\Report::REPORT_FORMAT_PDF) {
//
//            $url = "data:application/pdf;base64," . $reportDataEncoded;
//            //seta o id que strá usado no script
//            //esse não pode repetir caso sejam abertos dois relatórios,
//            //então adiciona-se um identificador, o nome do menu
//            if (!empty($menuNameParam)) {
//                $id = "pdf_" . $menuNameParam . "_" . $tab;
//            } elseif (!empty($menuNameEnv)) {
//                $id = "pdf_" . $menuNameEnv . "_" . $tab;
//            } else {
//                $id = "pdf_" . $window . "_" . $tab;
//            }
//            //seta o valor de "report", um campo do tipo RawText, com o object do relatório
//            //$reportEmbedCode='<object id="'.$id.'" type="application/pdf" src="'.$url.'" width="100%" height="100%"><p>Aparentemente você não possui o plugin do Adobe PDF instalado. <br/>Você pode salvar este arquivo para visualizar utilizando um visualizador de PDF em off-line. <a href="'.$url.'">click here to download the PDF file.</a></p> </object><script> 	$(document).ready(function(){		birtReport() 	}); 	$(window).resize(function(){ 		birtReport() 	}); 	 	function birtReport(){ 		var iframe = $("#'.$id.'");  		var formHeight = $("#content_'.$actualWindow.' .formHeight");  		iframe.height(formHeight.height());  		formHeight.attr("style","overflow-y: hidden !important"); 	 	}	 </script>';;
//            $reportEmbedCode = '<iframe id="' . $id . '" src="' . $url . '" width="100%" height="100%"><p>Aparentemente você não possui o plugin do Adobe PDF instalado. <br/>Você pode salvar este arquivo para visualizar utilizando um visualizador de PDF em off-line. <a href="' . $url . '">click here to download the PDF file.</a></p> </iframe><script> 	$(document).ready(function(){		birtReport() 	}); 	$(window).resize(function(){ 		birtReport() 	}); 	 	function birtReport(){ 		var iframe = $("#' . $id . '");  		var formHeight = $("#content_' . $actualWindow . ' .formHeight");  		iframe.height(formHeight.height());  		formHeight.attr("style","overflow-y: hidden !important"); 	 	}	 </script>';;
//            tk_set_field_value("report", $reportEmbedCode, $tab, $window);
//        }
//        //se não for um pdf, dispara o download do arquivo
//        else {
//            $url = "data:application/octet-stream;base64," . $reportDataEncoded;
//
//            //seta o id que strá usado no script
//            //esse não pode repetir caso sejam abertos dois relatórios,
//            //então adiciona-se um identificador, o nome do menu
//            if (!empty($menuNameParam)) {
//                $id = "download_" . $menuNameParam . "_" . $tab;
//            } elseif (!empty($menuNameEnv)) {
//                $id = "download_" . $menuNameEnv . "_" . $tab;
//            } else {
//                $id = "download_" . $window . "_" . $tab;
//            }
//            //cria um link dummy, que é clicado via script pra baixar o arquivo
//
//            //$pathToReport tem a path completa desde "reports" até o relatório
//            //então para pegar o nome propriamente dito é necessário explodir em /
//            // e pegar a ultima posição
//            $fileName=$reportName.'.'.strtolower($format);
//            $reportLinkCode =
//                '<a id="'.$id.'" download="'.$fileName.'" href="'.$url.'"></a>
//                <script type="text/javascript">
//                    $("#'.$id.'")[0].click();
//                </script>';
//            tk_set_field_value("link", $reportLinkCode, $tab, $window);
//        }
//    }

}