var dfs11000_LancamentoSaida_Controller = function(ScreenService, MessageService, templateManager, Df11000_Lancamento_Service, Dfs11000_LancamentoSaida_Service, General, ValidacoesEstoque_Service, Lib00206_InfComplProduto_Service, ZhFilterPreferences, ErrosReplicacaoDocumentos_Utilities, Lib00206_InfComplProduto_Controller, localStorageEngine, ZHPromise){
    
    var CDFILIEMIT;
    var atualizaEstoque;
    
    var getCabecalhoWidget      = function(){
        if(templateManager.container)
            return templateManager.container.getWidget("cabecalho");
    };
    
    var getImportacaoWidget = function(){
        if(templateManager.container)
            return templateManager.container.getWidget('importacaoSolicitacaoCompra');
    };

    var getItensWidget = function(){
        return templateManager.container.getWidget("itens");
    };
    
    var getImpostosItensWidget = function(){
        return templateManager.container.getWidget("impostosItem");
    };
    
    var requestError = function(error){
        var errorMessage = "Ocorreu um erro ao tentar realizar a operação.";
        if (error && error.data) {
            errorMessage = error.data.error;
        }
        ScreenService.showMessage(errorMessage, "ERROR");
    };
    
    //Função que ajusta casas decimais de valor unitario de acordo com o parametro
    //Desativada por enquanto até futura definição
    this.ajustaCasasDecimais = function(){
        var itemsWidget = getItensWidget();
        var fieldItem = itemsWidget.getField('VRUNITITEM');
        
        /*General.callRestEngine('df#/crud/paramgeral', 'FilterData', []).then(function(success) {
            if(success.dataset.paramgeral[0]){
                var paramgeral = success.dataset.paramgeral[0];
                fieldItem.mask.params.precision = paramgeral.NRDECITOTANF;
            }
        });*/
    };
    
    this.actVoltar = function(args) {
        var widget = args.owner.widget;
        General.backOrCancel(args);
        widget.reload();
    };
    
    this.actNovaNota = function(args) {
        Df11000_Lancamento_Service.removeDataSourceLancamentoNota();
        Df11000_Lancamento_Service.inicializaLancamento();
        Df11000_Lancamento_Service.setDataSourceLancamentoNota().then(function() {
            defaultValueIndicadorPresenca(args.owner.widget);
            alteraVisibilidadeCampoNaturezaOper(args.owner.widget, false);
            validaCampoModDocFiscal(args.owner.widget, []);
            //validaCampoEmpresa(args);
            validaCampoSerie(args.row, true);
            args.owner.widget.newRow();
            controlaStatusWidgets(args.owner.widget, args.owner.widget.name, false);
            buscaItensNotaOrigem = true;
            validaNumeroNF(args.owner.widget);
            setCamposDefaultValueCabecalho(args)
            .then(() => {
                    var widgetCabecalho = templateManager.container.getWidget('cabecalho');
                    widgetCabecalho.redraw();
                    //widgetCabecalho.reload();
                });
        });
    };

    var reloadWidgetsFilhas = function(widgetPai) {
        widgetPai.widgets.forEach(function(widgetFilha) {
            widgetFilha.reload();
        });
    };

    this.encargoOnChange = function(args){
        var field = args.owner.field;
        
        if (!field.value()){
            field.setValue(0);
        }
        controlaStatusWidgets(args.owner.field.widget.getParent(), args.owner.field.widget.name, false);
    };

    this.unidadeDestinatarioOnChange = function(widget) {
        var currentRow = widget.currentRow;
        
        if (currentRow.CDFILIRECE == currentRow.CDFILIEMIT) {
            ScreenService.showMessage("Unidade de origem deve ser diferente da unidade de destino.");
            currentRow.DSFILIRECE = null;
            currentRow.CDFILIRECE = null;
            currentRow.CDEMPRESARECE = null;
        }
        else if (currentRow.CDEMPRESARECE != currentRow.CDEMPRESA) {
            ScreenService.showMessage("Unidade de destino deve possuir a mesma empresa da nota fiscal.");
            currentRow.DSFILIRECE = null;
            currentRow.CDFILIRECE = null;
            currentRow.CDEMPRESARECE = null;
        }
        widget.reload();
    };

    this.destinatarioOnChange = function(field) {
        var currentRow = field.widget.currentRow;
        
        currentRow.DSINSJURNF = currentRow[field.name];
    };

    this.qtdiasvenrecOnChange = function(field) {
        var currentRow = field.widget.currentRow;
        
        if (currentRow.QTDIASVENREC) {
            var parentCurrentRow = field.widget.getParent().currentRow;
            currentRow.DTATUAVENREC = moment(parentCurrentRow.DTENTRSAID, "DD/MM/YYYY").add(currentRow.QTDIASVENREC, "days").format("DD/MM/YYYY");
        }
    };

    this.dtatuavenrecOnChange = function(field) {
        var currentRow = field.widget.currentRow;
        
        if (currentRow.DTATUAVENREC) {
            var parentCurrentRow = field.widget.getParent().currentRow;
            var dataNota = moment(parentCurrentRow.DTENTRSAID, "DD/MM/YYYY");
            var dataInserida = moment(currentRow.DTATUAVENREC, "DD/MM/YYYY");
            currentRow.QTDIASVENREC = dataInserida.diff(dataNota, "days").toString();
        }
    };

    var controlaStatusWidgets = function(widgetPai, nomeWidgetAtual, status){
        widgetPai.widgets.forEach(function(widg){
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(widgetPai.name !== nomeWidgetAtual)
            widgetPai.enabled = status;
    };

    this.criaDetalhesLancamentoWidgetAfterMoveRow = function(consultaLancamentoArgs) {
        //buscaItensNotaOrigem = true;
        return Df11000_Lancamento_Service.criaDetalhesLancamento(consultaLancamentoArgs.row).then(function(lancamentoSaida) {
            templateManager.container.getWidget("itens").dataSource.data = lancamentoSaida.ITENS;
            templateManager.container.getWidget("impostos").dataSource.data = lancamentoSaida.IMPOSTO;
            templateManager.container.getWidget("encargos").dataSource.data = lancamentoSaida.ENCARGO;
            templateManager.container.getWidget("vencimentos").dataSource.data = lancamentoSaida.VENCIMENTO;
            templateManager.container.getWidget("dados_adicionais").dataSource.data = lancamentoSaida.DADOSADICIONAIS;
            return true;
        });
    };

    this.removeDataSourcesConsultaLancSaidaActionEvent = function() {
        Df11000_Lancamento_Service.removeDataSourceLancamentoNota();
    };
    
    /* var alteraVisibilidadeRemetenteDestinatario = function(){
    //     var cabecalhoWidget = getCabecalhoWidget();
    //     var allFields = cabecalhoWidget.fields;
    //     var remetenteDestinatario = allFields.filter(function(field){
    //         return field.fieldGroup === "destinatario" || field.fieldGroup === "remetente";
    //     });
    //     remetenteDestinatario.forEach(function(field){
    //         field.showOnView = cabecalhoWidget.currentRow.IDSTATUS !== "D";
    //     });
    // };*/

    var validaEdicaoNota = function() {
        var cabecalhoWidget = getCabecalhoWidget();
        var statusNota = cabecalhoWidget.currentRow.IDSTATUS || 'D';
        var statusNotaTransmissao = cabecalhoWidget.currentRow.IDSTATUSNFE;
        var notaCanceladaOuAprvada = (statusNota === 'A' || statusNota === 'C');
        var notaTransmissao = (statusNotaTransmissao === 'T' || statusNotaTransmissao === 'A' || statusNotaTransmissao === 'C' || statusNotaTransmissao === 'D');
        var permiteEditarNota = (!notaCanceladaOuAprvada && !notaTransmissao && (statusNota === 'D' || statusNota === 'P'));
        var allActions = cabecalhoWidget.getActions();

        var invisibleActions   = allActions.filter(function(action) {
            var widgetName     = action.widget.name;
            var actionName     = action.name.toLowerCase();
            var isActionVoltar = (actionName.indexOf('voltar') === -1);
            var novaNota       = (actionName.indexOf('novo') !== -1 && widgetName === 'cabecalho');
            var zeedhiWidgets  = (widgetName !== 'filterPopup' && widgetName !== 'stripe');
            return (isActionVoltar && zeedhiWidgets && !novaNota);
        });
        invisibleActions.forEach(function(action) {
            if(action.name !== 'REPLICARDOCUMENTO' && action.name !== 'INVISIBLEACTION' && action.name != "COPIARNOTA") action.isVisible = permiteEditarNota;
            else action.isVisible = (statusNota !== 'D');
            var encargoInlineEdit = cabecalhoWidget.container.getWidget('encargos').getField('VRITEMENCA');
            if(!!permiteEditarNota)
                encargoInlineEdit.inlineEditable = "number";
            else
                delete encargoInlineEdit.inlineEditable;

            if (action.name.toLowerCase().indexOf('fecharnota') !== -1 && statusNota === 'P')
                action.isVisible = false;
        });
    };

    var validaEdicaoItensServico = function(cabecalhoWidget){
        if(cabecalhoWidget.currentRow.IDORIGDESTNF === "C"){
            var itensWidget = cabecalhoWidget.container.getWidget("itens");
            var item = itensWidget.dataSource.data[0];
            if(cabecalhoWidget.appliedFilter.FILTER_ROW.IDBLOQITNFAPUR === "S" &&
                itensWidget.dataSource.data.length !== 0 &&
                (item.CDSERVFILI || item.CDSERVFATU)){

                itensWidget.getAction("novoItem").isVisible = false;
                itensWidget.getAction("novoServico").isVisible = false;
            }
            else{
                itensWidget.getAction("novoItem").isVisible = true;
                itensWidget.getAction("novoServico").isVisible = true;
            }
        }
    };

    var alteraVisibilidadeBotaoIncluirServico = function(widget){
        if(widget.currentRow.IDORIGDESTNF === "C"){
            Dfs11000_LancamentoSaida_Service.retornaClienteFilial(
                widget.currentRow.CDFILIEMIT,
                widget.currentRow.CDCLIENTE).then(function(clienteFilial){
                    if(clienteFilial.length !== 0)
                        widget.container.getWidget("itens").getAction("novoServico").isVisible = true;
                    else
                        widget.container.getWidget("itens").getAction("novoServico").isVisible = false;
                });
        }
        else{
            widget.container.getWidget("itens").getAction("novoServico").isVisible = false;
        }
    };

    var alteraVisibilidadeActionsProduto = function() {

        var situacaoNFe  = getCabecalhoWidget().currentRow.IDSTATUSNFE; 
        var situacaoNF   = getCabecalhoWidget().currentRow.IDSTATUS; 
        var adicionar    = getItensWidget().actions.filter(action => action.name === 'novoItem')[0];
        var excluirItem  = getItensWidget().actions.filter(action => action.name === 'excluirItem')[0];
    
        if(situacaoNFe !== "undefined") {
            if((situacaoNFe == "R" || situacaoNFe == "P" || situacaoNF == "D" || situacaoNF == "P") && (getCabecalhoWidget().currentRow.IDOPERDEVONF != "S")) {
                adicionar.isVisible = true;
                excluirItem.isVisible = true;
            } else {
                adicionar.isVisible = false;
                excluirItem.isVisible = false;
            }
        }     
        
    };
    
    var validaNotaServico = function(cabecalhoWidget){
        validaEdicaoItensServico(cabecalhoWidget);
        alteraVisibilidadeBotaoIncluirServico(cabecalhoWidget);
    };

    this.validacoesNotaAfterMoveRow = function(args) {
        let widget = args.owner;
        
        Df11000_Lancamento_Service.removeDataSourceLancamentoNota();
        if(args.row.__is_new === false) {
            this.criaDetalhesLancamentoWidgetAfterMoveRow(args).then(function(){
                validaNotaServico(args.owner);
            });
        }
        alteraVisibilidadeCampoNaturezaOper(widget);
        validaNumeroNF(widget);
        validaEdicaoNota();
        // alteraVisibilidadeRemetenteDestinatario();
        alteraVisibilidadeCampoInscricao();
        //validaCamposDocumentoOrigem(getCabecalhoWidget(), args.row);
        preparaCamposDocumentoOrigem(args);
        
        widget.getField('NMTIPOOPER').reload().then(() => {
            let widget = templateManager.container.getActiveWidget();
            if(!widget.editing) { //True = Visualizar nota.
                this.controlVisibilityLocalPrestServ(widget);
            }
        });
        this.validacoesFieldGroupIntermediador(args.owner);

    };

    this.excluirNotaActionEvent = function(consultaLancamentoArgs) {
        ScreenService.confirmMessage('Deseja excluir a nota fiscal?', 'question', function (success) {
            var filter = [
                {
                    "name": "IDDOCREPLIC",
                    "operator": "=",
                    "value": consultaLancamentoArgs.row.CDFILIAL.concat(consultaLancamentoArgs.row.NRLANCTONF)
                }    
            ];
            General.callRestEngine('df_saida#/crud/notaReplicada_tipooperac', 'FilterData', filter).then(function(success) {
                if(success.dataset.notaReplicada_tipooperac[0]) this.openReplicacaoExclusao(consultaLancamentoArgs);
                else this.excluirNota(consultaLancamentoArgs);
            }.bind(this));
        }.bind(this));
    };
    
    this.excluirNota = function(consultaLancamentoArgs) {
        Dfs11000_LancamentoSaida_Service.excluirNota(consultaLancamentoArgs.row).then(function() {
            General.backOrCancel(consultaLancamentoArgs);
            var rowExcluida = consultaLancamentoArgs.owner.widget.dataSource.data.filter(function(notafiscal){
                return consultaLancamentoArgs.row.NRLANCTONF === notafiscal.NRLANCTONF;
            });
            var index = consultaLancamentoArgs.owner.widget.dataSource.data.indexOf(rowExcluida[0]);
            consultaLancamentoArgs.owner.widget.dataSource.data.splice(index, 1);
            consultaLancamentoArgs.owner.widget.reload();
            ScreenService.showMessage('Nota Fiscal excluída com sucesso');
        }, function (error) {
            requestError(error);
        });
    };
    
    var alteraStatusNotafiscal = function(widget){
        if(widget.getParent().currentRow.IDSTATUS !== 'D'){
            widget.getParent().currentRow.IDSTATUS = 'D';
            Df11000_Lancamento_Service.salvaCabecalho(widget.getParent().currentRow).then(function(){}, requestError);
            // alteraVisibilidadeRemetenteDestinatario();
            validaEdicaoNota();
        }
    };
    
    var confereFilialLogada = function(lancamentoCabecalhoArgs){
        var deferred = ZHPromise.defer();
        if(!lancamentoCabecalhoArgs.row.hasOwnProperty('CDFILIAL')){
          Dfs11000_LancamentoSaida_Service.getFilial().then(function(result){
              lancamentoCabecalhoArgs.row.CDFILIAL = result.dataset.filial[0].CDFILIAL;
              deferred.resolve();
          });
        }
        else{
            deferred.resolve();
        }
        return deferred;
    };

    this.salvaLancamentoCabecalho = function(lancamentoCabecalhoArgs) {
        
     confereFilialLogada(lancamentoCabecalhoArgs).then(function(success){

        if (lancamentoCabecalhoArgs.owner.widget.isValid()) {
            if (!lancamentoCabecalhoArgs.row.NRINSJURCLIE && !lancamentoCabecalhoArgs.row.CDFILIRECE && !lancamentoCabecalhoArgs.row.DSINSJURNF)
                return ScreenService.showMessage("Destinatário da Nota Fiscal não informado.");

            if (lancamentoCabecalhoArgs.row.CDFILIRECE) {
                if (lancamentoCabecalhoArgs.row.CDFILIRECE == lancamentoCabecalhoArgs.row.CDFILIEMIT) {
                    lancamentoCabecalhoArgs.row.DSFILIRECE = null;
                    lancamentoCabecalhoArgs.row.CDFILIRECE = null;
                    lancamentoCabecalhoArgs.row.CDEMPRESARECE = null;
                    return ScreenService.showMessage("Unidade de origem deve ser diferente da unidade de destino.");
                }
                else if (lancamentoCabecalhoArgs.row.CDEMPRESARECE != lancamentoCabecalhoArgs.row.CDEMPRESA) {
                    lancamentoCabecalhoArgs.row.DSFILIRECE = null;
                    lancamentoCabecalhoArgs.row.CDFILIRECE = null;
                    lancamentoCabecalhoArgs.row.CDEMPRESARECE = null;
                    return ScreenService.showMessage("Unidade de destino deve possuir a mesma empresa da nota fiscal.");
                }
            }

            ValidacoesEstoque_Service.validaDataLancamento(lancamentoCabecalhoArgs.row.CDFILIEMIT, lancamentoCabecalhoArgs.row.DTENTRSAID, "SAIDA", "DFS").then(function(){
                if(lancamentoCabecalhoArgs.row.__is_new){
                    //lancamentoCabecalhoArgs.row.__new_code_pk = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__new_code_pk+lancamentoCabecalhoArgs.row.CDFILIAL;
                    lancamentoCabecalhoArgs.row.__new_code_pk = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__new_code_pk;
                    lancamentoCabecalhoArgs.row.__using_unit = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__using_unit;
                    lancamentoCabecalhoArgs.row.__table_pk = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__table_pk;
                    lancamentoCabecalhoArgs.row.__new_code_length = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__new_code_length || 5;
                    lancamentoCabecalhoArgs.row.__columns_to_return = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__columns_to_return;
                    lancamentoCabecalhoArgs.row.VRPRODUTOS = 0;
                    lancamentoCabecalhoArgs.row.VRNOTAFISC = 0;
                    lancamentoCabecalhoArgs.row.IDENTRSAIDOP = "S";
                    lancamentoCabecalhoArgs.row.IDBLOQUEADO = "N";
                    lancamentoCabecalhoArgs.row.IDSISTEMA = "DFS";
                    lancamentoCabecalhoArgs.row.IDDOCFINANC = "S";
                }

                lancamentoCabecalhoArgs.row.IDSTATUS     = "D";
                lancamentoCabecalhoArgs.row.CDINSCESTA   = lancamentoCabecalhoArgs.row.IEREM;
                lancamentoCabecalhoArgs.row.NRSEQCAPADOC = "";
                lancamentoCabecalhoArgs.row.DTCOMPFATUR  = moment().format("DD/MM/YYYY LTS");
                
                Df11000_Lancamento_Service.salvaCabecalho(lancamentoCabecalhoArgs.row).then(function(callback){
                    var rowDADOSERVPRESnew = false;

                    if(lancamentoCabecalhoArgs.row.__is_new){
                        if(lancamentoCabecalhoArgs.row.IDUTILNFSE === 'S') rowDADOSERVPRESnew = true;
                        lancamentoCabecalhoArgs.row.CDFILIAL = callback.dataset.columnsToReturn[0].CDFILIAL;
                        lancamentoCabecalhoArgs.row.NRLANCTONF = callback.dataset.columnsToReturn[0].NRLANCTONF;
                        lancamentoCabecalhoArgs.row.NRORG = callback.dataset.columnsToReturn[0].NRORG;

                        //OPERAÇÕES DE DEVOLUÇÃO E COMPLEMENTO 
                        if((lancamentoCabecalhoArgs.row.IDOPERDEVONF === 'S' || lancamentoCabecalhoArgs.row.CDTIPOOPER == '03' ) && lancamentoCabecalhoArgs.row.__is_new === true){
                            lancamentoCabecalhoArgs.row.CDFILIALIT = lancamentoCabecalhoArgs.row.CDFILINOTAORIG;
                            lancamentoCabecalhoArgs.row.NRLANCTONFIT = lancamentoCabecalhoArgs.row.NRLANCNOTAORIG;
                            lancamentoCabecalhoArgs.row.NRSEQUITNOTA = "001";

                            var itemnotafisc = {
                                "CDFILIAL": lancamentoCabecalhoArgs.row.CDFILIAL,
                                "NRLANCTONF": lancamentoCabecalhoArgs.row.NRLANCTONF,
                                "CDFILIALIT": lancamentoCabecalhoArgs.row.CDFILINOTAORIG,
                                "NRLANCTONFIT": lancamentoCabecalhoArgs.row.NRLANCNOTAORIG,
                                "NRSEQUITNOTA": "001",
                                "__is_new": true
                            };
                            Df11000_Lancamento_Service.salvaItemnotafisc(itemnotafisc).then(function(){}, requestError);
                        }
                        //@todo remover __is_new quando widget.edit() funcionar
                        lancamentoCabecalhoArgs.row.__is_new = false;
                        reloadWidgetsFilhas(lancamentoCabecalhoArgs.owner.widget);
                    }
                    Df11000_Lancamento_Service.setDataSourceCabecalho(lancamentoCabecalhoArgs.row);
                    Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                    lancamentoCabecalhoArgs.owner.widget.view();
                    validaEdicaoNota();
                    habilitaCamposItemNotaOrigem(getItensWidget(), lancamentoCabecalhoArgs.row);
                    alteraVisibilidadeBotaoIncluirServico(lancamentoCabecalhoArgs.owner.widget);
                    // alteraVisibilidadeRemetenteDestinatario();
                    controlaStatusWidgets(lancamentoCabecalhoArgs.owner.widget, lancamentoCabecalhoArgs.owner.widget.name, true);
                    
                    if(lancamentoCabecalhoArgs.row.IDUTILNFSE === 'S') {
                        let rowDADOSERVPRES = setRowDADOSERVPRES(lancamentoCabecalhoArgs.row);
                        
                        if(rowDADOSERVPRESnew) {
                            rowDADOSERVPRES.__is_new         = true;
                            General.callRestEngine('df#/crud/dadoservpres/save', "Row", rowDADOSERVPRES);
                        }
                        else {
                            let filter = [{"name":"CDFILIAL"  , "operator":"=", "value": rowDADOSERVPRES.CDFILIAL},
                                          {"name":"NRLANCTONF", "operator":"=", "value": rowDADOSERVPRES.NRLANCTONF}];
                                          
                            General.callRestEngine('df#/crud/dadoservpres', 'FilterData', filter)
                                .then((sucess) => {
                                    rowDADOSERVPRES.__is_new = sucess.dataset.dadoservpres.length ? false : true;
                                    General.callRestEngine('df#/crud/dadoservpres/save', "Row", rowDADOSERVPRES);
                                });
                        }
                    }
                }, requestError);
            }, requestError);
        }
     });
    };
    
    var setRowDADOSERVPRES = function(lancamentoCabecalhoArgsRow){
        let rowDADOSERVPRES = {};
        rowDADOSERVPRES.CDFILIAL             = lancamentoCabecalhoArgsRow.CDFILIAL;
        rowDADOSERVPRES.NRLANCTONF           = lancamentoCabecalhoArgsRow.NRLANCTONF;
        rowDADOSERVPRES.IDNATUOPER           = lancamentoCabecalhoArgsRow.IDNATUOPER;
        rowDADOSERVPRES.CDPAISPRESSERV       = lancamentoCabecalhoArgsRow.CDPAISNOTA;
        rowDADOSERVPRES.SGESTADOPRESSERV     = lancamentoCabecalhoArgsRow.SGESTADONOTA;
        rowDADOSERVPRES.CDMUNICIPRESSERV     = lancamentoCabecalhoArgsRow.CDMUNICIPIONOTA;
        rowDADOSERVPRES.NRORG                = lancamentoCabecalhoArgsRow.NRORG;
        rowDADOSERVPRES.IDATIVO              = 'S';
        return rowDADOSERVPRES;
    };

    this.actEditarCabecalhoOnClick = function(detalhesCabecalhoArgs) {
        General.edit(detalhesCabecalhoArgs.owner.widget);
        controlaStatusWidgets(detalhesCabecalhoArgs.owner.widget, detalhesCabecalhoArgs.owner.widget.name, false);
        validaCampoModDocFiscal(detalhesCabecalhoArgs.owner.widget, detalhesCabecalhoArgs.row);
        alteraVisibilidadeCampoNaturezaOper(detalhesCabecalhoArgs.owner.widget);
        changeDataSourceNotaOrigem(detalhesCabecalhoArgs.owner.widget);
        this.controlVisibilityLocalPrestServ(detalhesCabecalhoArgs.owner.widget);
        validaCampoSerie(detalhesCabecalhoArgs.row);
    };

    this.getCurrentField = function(field) {
        var cabecalhoWidget = getCabecalhoWidget();
        if (cabecalhoWidget)
             return !cabecalhoWidget.currentRow[field] ? null : cabecalhoWidget.currentRow[field];
        return null;
    };

    this.getSequencialItemSelecionado = function(args){
        return '0001';
    };

    var validaCampoModDocFiscal = function(lancamentoCabecalhoWidget, lancamentoCabecalhoRow) {
         var descModFisc = lancamentoCabecalhoWidget.getField("DSMODDOCFISC");
         descModFisc.readOnly = !lancamentoCabecalhoRow.CDTIPOOPER;

         var tipoOperac = lancamentoCabecalhoRow.CDTIPOOPER;
         if (tipoOperac === "09" || tipoOperac === "10")
             delete descModFisc.validations;
         else
             descModFisc.validations = {"required": true};
    };

    var validaCampoEmpresa = function(lancamentoCabecalhoArgs) {
        var empresa = getCabecalhoWidget().getField("NMEMPRESA");
        empresa.readOnly = !lancamentoCabecalhoArgs.row.CDFILIEMIT;
    };

    var validaCampoSerie = function(lancamentoCabecalhoRow, limpaCampo) {
        var serie = getCabecalhoWidget().getField("DSSERIE");
        serie.readOnly = !lancamentoCabecalhoRow.NMEMPRESA;

        if (!!limpaCampo)
            serie.value(null);

        var tipoOperac = lancamentoCabecalhoRow.CDTIPOOPER;
        if (lancamentoCabecalhoRow.IDSERIEAUTO === 'S' && (tipoOperac === "09" || tipoOperac === "10"))
            delete serie.validations;
        else
            serie.validations = {"required": true};
    };

    var limpaCamposOutDataSelectsTpOperac = function(widget)    {
         widget =  !widget ? getCabecalhoWidget() : widget; 
        var cabecalhoWidget = getCabecalhoWidget();
        var cabecalhoRow = widget.currentRow;
        var cliente = widget.getField("NMRAZSOCCLIE");
        var fornecedor = widget.getField("NMRAZSOCFORN");
        var filial = widget.getField("DSFILIRECE");

        filial.value(null); 
         
        cliente.value(null);
        cabecalhoRow.CDCLIENTE = null;

        fornecedor.value(null);
        cabecalhoRow.CDFORNECED = null;
        cabecalhoRow.IDSITUCADA = null;
        cabecalhoRow.IDBLQNFRELAFOAF = null;

        cabecalhoRow.NRINSJURNF = null;
        cabecalhoRow.NMINSJURNF = null;
        cabecalhoRow.IDTPIJURNF = null;
    };

    var setCampoObrigatorio = function(field, readOnly = false) {
        field.isVisible = true;
        field.validations = {"required": true};
        field.readOnly = readOnly;
    };

    var setCampoNaoObrigatorio = function(field) {
        field.isVisible = false;
        delete field.validations;
        field.readOnly = true;
    };

    var validacaoCamposOutTpOperac = function(princialField) {
        setCampoObrigatorio(princialField);
        princialField.showOnView = true;
        princialField.showOnForm = true;
        princialField.isVisible = true;

        for (var i = 1; i < arguments.length; i++) {
            setCampoNaoObrigatorio(arguments[i]);
            arguments[i].showOnView = false;
            arguments[i].showOnForm = false;
            arguments[i].isVisible = false;
        }
    };

    var preparaCamposDocumentoOrigem = function(args){
        habilitaCamposCabecalhoNotaOrigem(args.owner, args.row);
        habilitaCamposItemNotaOrigem(getItensWidget(), args.row);
    };

    var validaCamposDocumentoOrigem = function(lancamentoCabecalhoWidget, lancamentoCabecalhoRow) {
        var serieOrigem = lancamentoCabecalhoWidget.getField("CDSERIEORIGEM");
        var notaOrigem = lancamentoCabecalhoWidget.getField("DSNOTAORIGEM");
        var tipoDestino = lancamentoCabecalhoRow.IDORIGDESTOP || lancamentoCabecalhoRow.IDORIGDESTNF;
        var destinatario;

        switch (tipoDestino) {
            case "C":
                destinatario = lancamentoCabecalhoWidget.getField("NMRAZSOCCLIE");
                break;
            case "F":
                destinatario = lancamentoCabecalhoWidget.getField("NMRAZSOCFORN");
                break;
            case "L":
                destinatario = lancamentoCabecalhoWidget.getField("DSFILIRECE");
                break;
        }

        //serieOrigem.value(null);
        //notaOrigem.value(null);

        //lancamentoCabecalhoRow.CDFILINOTAORIG = null;
        //lancamentoCabecalhoRow.NRNOTAFISCORIGEM = null;
        //lancamentoCabecalhoRow.NRLANCNOTAORIG = null;

        habilitaCamposItemNotaOrigem(getItensWidget(), lancamentoCabecalhoRow);

        if ((lancamentoCabecalhoRow.IDNFORIGOBRI == "S" && lancamentoCabecalhoRow.IDOPERDEVONF == "S" ) || lancamentoCabecalhoRow.CDTIPOOPER == "03") {
            setCampoObrigatorio(serieOrigem, !destinatario.value());
            setCampoObrigatorio(notaOrigem, !destinatario.value());
            return true;
        }
        
        setCampoNaoObrigatorio(serieOrigem);
        setCampoNaoObrigatorio(notaOrigem);
        return false;
    };

    this.idorigdestOnChange = function(filterArgs) {
        alteraVisibilidadeCampoInscricaoFiltro(filterArgs);
        limpaCamposOutDataSelectsTpOperacFiltro(filterArgs);
    };

    var alteraVisibilidadeCampoInscricaoFiltro = function(filterArgs) {
        var filtroWidget = filterArgs.owner.field.widget;
        var cliente = filtroWidget.getField("NMRAZSOCCLIE");
        var fornecedor = filtroWidget.getField("NMRAZSOCFORN");
        var filial = filtroWidget.getField("DSFILIRECE");
        var tipoDestino = filterArgs.row.IDORIGDESTNF;

        switch (tipoDestino) {
            case "C":
                validacaoCamposOutTpOperacFilter(cliente, fornecedor, filial);
                break;
            case "F":
                validacaoCamposOutTpOperacFilter(fornecedor, cliente, filial);
                break;
            case "L":
                validacaoCamposOutTpOperacFilter(filial, fornecedor, cliente);
                break;
            default:
                filial.readOnly = true;
                cliente.readOnly = true;
                fornecedor.readOnly = true;
                filtroWidget.currentRow.DSFILIRECE = null;
                filtroWidget.currentRow.NMRAZSOCCLIE = null;
                filtroWidget.currentRow.NMRAZSOCFORN = null;
        }
    };

    var validacaoCamposOutTpOperacFilter = function(princialField) {
        princialField.showOnView = true;
        princialField.showOnForm = true;
        princialField.isVisible = true;
        princialField.readOnly = false;

        for (var i = 1; i < arguments.length; i++) {
            arguments[i].showOnView = false;
            arguments[i].showOnForm = false;
            arguments[i].isVisible = false;
            arguments[i].readOnly = true;
        }
    };

    this.tipoOperacaoOnChange = function(cabecalhoArgs) {
        var hasFieldValueFilial = !!cabecalhoArgs.owner.field.value();
        var cabecalhoRow = cabecalhoArgs.row;
        var cabecalhoWidget = cabecalhoArgs.owner.field.widget;

        cabecalhoRow.IDORIGDESTNF = cabecalhoRow.IDORIGDESTOP;

        alteraVisibilidadeCampoInscricao();
        alteraVisibilidadeCampoNaturezaOper(cabecalhoWidget, true);

        validaCampoModDocFiscal(cabecalhoWidget, cabecalhoRow);
        validaCamposDocumentoOrigem(cabecalhoWidget, cabecalhoRow);
        validaCampoSerie(cabecalhoRow);
        validaNumeroNF(cabecalhoWidget);
        limpaCamposOutDataSelectsTpOperac();
        this.controlVisibilityLocalPrestServ(cabecalhoWidget);
        changeDataSourceNotaOrigem(cabecalhoWidget);
        
        if(cabecalhoWidget.currentRow.__is_new)
            defaultValueIndicadorPresenca(cabecalhoWidget);
    };

    var limpaCamposOutDataSelectsTpOperacFiltro = function(filterArgs)    {
        var filtroWidget = filterArgs.owner.field.widget;
        var cabecalhoRow = filtroWidget.currentRow;
        var cliente = filtroWidget.getField("NMRAZSOCCLIE");
        var fornecedor = filtroWidget.getField("NMRAZSOCFORN");
        var filial = filtroWidget.getField("DSFILIRECE");

        filial.value(null);

        cliente.value(null);
        cabecalhoRow.CDCLIENTE = null;

        fornecedor.value(null);
        cabecalhoRow.CDFORNECED = null;
        cabecalhoRow.IDSITUCADA = null;
        cabecalhoRow.IDBLQNFRELAFOAF = null;

        cabecalhoRow.NRINSJURNF = null;
        cabecalhoRow.NMINSJURNF = null;
        cabecalhoRow.IDTPIJURNF = null;
    };

    this.cdfiliemitOnChange = function(lancamentoCabecalhoArgs) {
        lancamentoCabecalhoArgs.owner.field.widget.getField('NMRAZSOCCLIE').reload();
        CDFILIEMIT = lancamentoCabecalhoArgs.row.CDFILIEMIT;
        //validaCampoEmpresa(lancamentoCabecalhoArgs);
        validaCampoSerie(lancamentoCabecalhoArgs.row);
        applyZeroFillNumeroNota(lancamentoCabecalhoArgs.owner.field.widget);
    };

    this.empresaOnChange = function(lancamentoCabecalhoArgs) {
         validaCampoSerie(lancamentoCabecalhoArgs.row, true);
         validaCamposDocumentoOrigem(getCabecalhoWidget(), lancamentoCabecalhoArgs.row);
    };

    this.fornecedorOnChange = function(lancamentoCabecalhoArgs) {
         validaCamposDocumentoOrigem(getCabecalhoWidget(), lancamentoCabecalhoArgs.row);
    };
    
    this.validacoesWidgetOnEnterOnce = function(consultaLancamentoArgs) {
        var cabecalhoWidget = consultaLancamentoArgs.owner;
        setDefaultFilialFilter(cabecalhoWidget).then(defaultFilter => {
            ZhFilterPreferences.setOriginalFilter(cabecalhoWidget.id, defaultFilter);
            ZhFilterPreferences.openFilterWidget(cabecalhoWidget, defaultFilter).then (response => {
                var filterWidget = templateManager.container.getActiveWidget();
                filterWidget.actions.filter(action => action.name === "clear")[0].shortcutKey = "ctrl+backspace";
            });
            CDFILIEMIT = defaultFilter.CDFILIEMIT;
            cabecalhoWidget.getField('NMTIPOOPER').reload();
        });
    };
    
 
    var setDefaultFilialFilter = function(cabecalhoWidget) {
        var promise = ZHPromise.defer();
        let defaultFilter = Util.clone(cabecalhoWidget.currentRow);
        defaultFilter.DTENTRSAID = undefined;

        General.callRestEngine('df#/filioper_lancamento_notafiscal', 'FilterData', [{"name": "CDOPERADOR", "operator": "=", "value": "OPERADOR_LOGADO"},
                                                                                    {"name": "CDFILIAL"  , "operator": "=", "value": "FILIAL_LOGADA"}]
            ).then(function(filialLogada) {
                let filialDefaultValue, cdFilialOut = null;
                let filialFieldOutData = cabecalhoWidget.getField('NMFILIAL').outData;
                
                //Utiliza o primeiro dataset retornado. Necessário pois o dataset pode ser filioper_lancamento_notafiscal ou perfacessfili_lancamento_notafiscal
                for (let datasetName in filialLogada.dataset) {
                    if (filialLogada.dataset.hasOwnProperty(datasetName)) {
                        filialDefaultValue = filialLogada.dataset[datasetName][0];
                	    break;
                    }
                }
                if(filialDefaultValue) cdFilialOut = filialDefaultValue.CDFILIAL;
                
                Df11000_Lancamento_Service.buscaDataProcessamento(cdFilialOut).then(([processamento]) => {
                    if(processamento) {
                        const dtProcessFormat = moment(processamento.DTPROCESSA, 'DD/MM/YYYY').format('DD/MM/YYYY');
                        defaultFilter.DTENTRSAID = {start: dtProcessFormat, period: undefined, end: dtProcessFormat};
                    }
                    promise.resolve(defaultFilter);
                });
                setCurrentRowWithOutData(defaultFilter, filialDefaultValue, filialFieldOutData);
        });
        return promise;
    };
    
    /*var setCurrentRowWithOutDataFilial = function(filialOut, filialField, currentRow, dtEntrField) {
        var promise = ZHPromise.defer(); 
        General.callRestEngine('df#/crud/filioper_lancamento_notafiscal', 'FilterData', [{"name": "CDFILIAL", "operator": "=", "value": filialOut}]).then(function(success){
            var defaultValue = success.dataset.filial[0]; 
            var filialOutData = filialField.outData;
            Df11000_Lancamento_Service.buscaDataProcessamento(filialOut).then(([processamento]) => {
                const dtProcessFormat = moment(processamento.DTPROCESSA, 'DD/MM/YYYY').format('DD/MM/YYYY');
                currentRow.DTENTRSAID = {start: dtProcessFormat, period: undefined, end: dtProcessFormat};
                promise.resolve();
            });
            setCurrentRowWithOutData(currentRow, defaultValue, filialOutData);
        });
            
        return promise;
    };*/
    
    this.getDataProcessamento = function(filialSelecionada){
        var promise = ZHPromise.defer();
        Df11000_Lancamento_Service.buscaDataProcessamento(filialSelecionada).then(function(processamento){
            var dtProcessFormat = moment(processamento[0].DTPROCESSA, 'DD/MM/YYYY').format('DD/MM/YYYY');
            promise.resolve(dtProcessFormat);
        });
        return promise;
    };
    
    var setCurrentRowWithOutData = function(currentRow, valuesToSetOnCurrentRow, outDataValue) {
        for (var key in outDataValue) {
            currentRow[outDataValue[key]] = valuesToSetOnCurrentRow[key];
        }
    };
    
    
    
    const reloadSerie = widget => {
        const field = widget.getField('DSSERIE');
        field.reload();
    };
    
    const reloadCampoTipoOperacao = widget => {
        var deferred = ZHPromise.defer();
        const field = widget.getField('NMTIPOOPER');
        field.reload().then(() => {
                var data = field.dataSource.data;
                if (!data || !data.length)
                    return false;

                const {currentRow} = field.widget;
                const defaultRow = data.find(operacao => operacao.CDTIPOOPER === '01');
                if(defaultRow)
                    setCurrentRowWithOutData(currentRow, defaultRow, field.outData);
                else
                    field.value(null);
                field.change();
                deferred.resolve();
            });
        return deferred;
    };
    
    var setCamposDefaultValueCabecalho = function(lancamentoCabecalhoArgs) {
        var deferred = ZHPromise.defer();
        Df11000_Lancamento_Service.getDefaultNovaNotaSaida().then((defaultNota) => {
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMFILIAL = defaultNota[0].NMFILIAL;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDFILIEMIT = defaultNota[0].CDFILIEMIT;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMEMPRESA = defaultNota[0].NMEMPRESA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDEMPRESA = defaultNota[0].CDEMPRESA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDINSCESTA = defaultNota[0].CDINSCESTA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDINSCMUNI = defaultNota[0].CDINSCMUNI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDSERIE = defaultNota[0].CDSERIE;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DSSERIE = defaultNota[0].DSSERIE;
            lancamentoCabecalhoArgs.owner.widget.currentRow.OPERADOR = defaultNota[0].CDOPERADOR;
            lancamentoCabecalhoArgs.owner.widget.currentRow.IEREM = defaultNota[0].CDINSCESTA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.SGESTADOREM = defaultNota[0].SGESTADO;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMMUNICIPIOREM = defaultNota[0].NMMUNICIPIO;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DSENDEREM = defaultNota[0].DSENDEFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMBAIRREM = defaultNota[0].NMBAIRFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NRCEPREM = defaultNota[0].NRCEPFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NRTELEREM = defaultNota[0].NRTELEFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDOPERGERA = defaultNota[0].CDOPERADOR;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DTENTRSAID = defaultNota[0].DTENTRSAID;
            
            reloadCampoTipoOperacao(lancamentoCabecalhoArgs.owner.widget);
            reloadSerie(lancamentoCabecalhoArgs.owner.widget);

            
            validaCampoSerie(lancamentoCabecalhoArgs.row);
            deferred.resolve();
        });
        return deferred;
    };

/*    var setCamposDefaultValueCabecalho = function(lancamentoCabecalhoArgs) {
        var deferred = ZHPromise.defer();
        Df11000_Lancamento_Service.buscaOperadorLogado().then(function(operador){
            var defaultValue = lancamentoCabecalhoArgs.owner.widget.getField('NMFILIAL').dataSource.data.filter(function(data) {
                //@todo filial logada
                return data.CDFILIAL == operador[0].CDFILIALSELECIONADA;
            });
            defaultValue = defaultValue[0];
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMFILIAL = defaultValue.NMFILIAL;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDFILIEMIT = defaultValue.CDFILIAL;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMEMPRESA = defaultValue.NMEMPRESA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDEMPRESA = defaultValue.CDEMPRESA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDINSCESTA = defaultValue.CDINSCESTA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDINSCMUNI = defaultValue.CDINSCMUNI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDSERIE = defaultValue.CDSERIE;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DSSERIE = defaultValue.DSSERIE;
            lancamentoCabecalhoArgs.owner.widget.currentRow.OPERADOR = defaultValue.CDOPERADOR;
            lancamentoCabecalhoArgs.owner.widget.currentRow.IEREM = defaultValue.CDINSCESTA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.SGESTADOREM = defaultValue.SGESTADO;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMMUNICIPIOREM = defaultValue.NMMUNICIPIO;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DSENDEREM = defaultValue.DSENDEFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMBAIRREM = defaultValue.NMBAIRFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NRCEPREM = defaultValue.NRCEPFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NRTELEREM = defaultValue.NRTELEFILI;

            Df11000_Lancamento_Service.buscaDataProcessamento(operador[0].CDFILIALSELECIONADA).then(function(processamento){
                var dtProcess = processamento[0].DTPROCESSA;
                var dtProcessFormat = moment(dtProcess, 'DD/MM/YYYY').format('DD/MM/YYYY');
                                var today = moment().format('DD/MM/YYYY');
                                var nowFullTime = moment().format('DD/MM/YYYY');
                                if(dtProcessFormat === today){
                                  dtProcessFormat = nowFullTime;
                                }else{
                                    dtProcessFormat = moment(dtProcess, 'DD/MM/YYYY').format('DD/MM/YYYY');
                                }
                lancamentoCabecalhoArgs.owner.widget.currentRow.DTENTRSAID = dtProcessFormat;
            });

            validaCampoSerie(lancamentoCabecalhoArgs.row);
            deferred.resolve();
        });
        return deferred;
    };*/

    this.cancelaEdicaoCabecalho = function(args){
        General.backOrCancel(args).then(function(){
            alteraVisibilidadeCampoInscricao();
            controlaStatusWidgets(args.owner.widget, args.owner.widget.name, true);
        });
        args.owner.widget.reload();
    };
    
    this.dateOnChange = function(dateField){
        var today = moment().format('DD/MM/YYYY');
        var nowFullTime = moment().format('DD/MM/YYYY');
        if(moment(dateField.value(), 'DD/MM/YYYY').format('DD/MM/YYYY') === today)
            dateField.value(nowFullTime);
    };

    var alteraVisibilidadeCampoInscricao = function(widget) {
        widget =  !widget ? getCabecalhoWidget() : widget  ; 
        var cabecalhoWidget = getCabecalhoWidget();
        var cabecalhoCurrentRow = widget.currentRow;
        var cliente = widget.getField("NMRAZSOCCLIE");
        var fornecedor = widget.getField("NMRAZSOCFORN");
        var filial = widget.getField("DSFILIRECE");
        var tipoDestino = cabecalhoCurrentRow.IDORIGDESTOP || cabecalhoCurrentRow.IDORIGDESTNF;

        switch (tipoDestino) {
            case "C":
                validacaoCamposOutTpOperac(cliente, fornecedor, filial);
                break;
            case "F":
                validacaoCamposOutTpOperac(fornecedor, cliente, filial);
                break;
            case "L":
                validacaoCamposOutTpOperac(filial, fornecedor, cliente);
                break;
            default:
                filial.readOnly = true;
                cliente.readOnly = true;
                fornecedor.readOnly = true;
        }
    };

    this.actNovoDadosAdicionaisOnClick = function(args) {
        args.owner.widget.newRow();
        Df11000_Lancamento_Service.getProxSeqDadosAdicionais().then(function(nrdadoadic){
           args.owner.widget.currentRow.NRDADOADIC = nrdadoadic;
        });
    };

    this.actEditarDadosAdicionaisOnClick = function(detalhesDadosAdicionaisWidget) {
        General.edit(detalhesDadosAdicionaisWidget);
    };

    this.limpaCampoCodigoDadosAdic = function(dadosAdicArgs) {
        dadosAdicArgs.row.CDMENSAGEM = null;
    };

    this.actIncluirDadosAdicionaisOnClick = function(lancamentoDadosAdicionaisArgs) {
         if (lancamentoDadosAdicionaisArgs.owner.widget.isValid()) {
            lancamentoDadosAdicionaisArgs.row.NRLANCTONF = lancamentoDadosAdicionaisArgs.owner.widget.getParent().currentRow.NRLANCTONF;
            lancamentoDadosAdicionaisArgs.row.CDFILIAL = lancamentoDadosAdicionaisArgs.owner.widget.getParent().currentRow.CDFILIAL;

            Df11000_Lancamento_Service.salvaDadosAdicionais(lancamentoDadosAdicionaisArgs.row).then(function() {
                alteraStatusNotafiscal(lancamentoDadosAdicionaisArgs.owner.widget);
                var closeSwipe = lancamentoDadosAdicionaisArgs.row.__is_new === true;
                //@todo remover __is_new quando widget.edit() funcionar
                lancamentoDadosAdicionaisArgs.row.__is_new = false;
                Df11000_Lancamento_Service.setDataSourceDadosAdicionais(lancamentoDadosAdicionaisArgs.row).then(function(){
                    Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        General.backOrCancel(lancamentoDadosAdicionaisArgs);
                        if(closeSwipe)
                            ScreenService.closeSwipe();
                        lancamentoDadosAdicionaisArgs.owner.widget.reload();
                    });
                });
            }, requestError);
         }
    };

    this.actExcluirDadosAdicionaisOnClick = function(lancamentoDadosAdicionaisArgs) {
        ScreenService.confirmMessage('Deseja excluir a mensagem?', 'question', function (success) {
            Df11000_Lancamento_Service.excluiDadosAdicionais(lancamentoDadosAdicionaisArgs.row).then(function () {
                alteraStatusNotafiscal(lancamentoDadosAdicionaisArgs.owner.widget);
                Df11000_Lancamento_Service.excluiDadosAdicionaisDataSource(lancamentoDadosAdicionaisArgs.row.NRDADOADIC).then(function () {
                    Df11000_Lancamento_Service.atualizaLancamento().then(function () {
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        General.backOrCancel(lancamentoDadosAdicionaisArgs);
                        lancamentoDadosAdicionaisArgs.owner.widget.reload();
                    });
                });
            }, requestError);
        });
    };

    this.setDtsEncargoOnEnter = function(lancamentoEncargoArgs) {
        if((lancamentoEncargoArgs.owner.getParent().currentRow.IDSTATUS === "D") && (!lancamentoEncargoArgs.owner.dataSource.data || !lancamentoEncargoArgs.owner.dataSource.data.length)){
            Df11000_Lancamento_Service.buscaEncargosPadrao().then(function(encargos){
                encargos.forEach(function(encargo){
                    encargo.VRITEMENCA = 0;
                    encargo.NRLANCTONF = lancamentoEncargoArgs.owner.getParent().currentRow.NRLANCTONF;
                    encargo.CDFILIAL = lancamentoEncargoArgs.owner.getParent().currentRow.CDFILIAL;
                    encargo.VRENMOEDESTR = "";
                    encargo.IDALTERADO = "N";
                    encargo.__is_new = true;
                });
                Df11000_Lancamento_Service.setDataSourceEncargo(encargos).then(function(){
                    lancamentoEncargoArgs.owner.currentRow = encargos;
                    lancamentoEncargoArgs.owner.reload();
                });
            }, requestError);
        }
    };

    this.salvaEncargoInlineEdit = function(lancamentoEncargoArgs) {
        var encargosSalvar;
         if (lancamentoEncargoArgs.owner.isValid()) {
         //    GerUtil.desmarcaLinhasEditadas(lancamentoEncargoOwner, SALVAR);
             if(lancamentoEncargoArgs.row.__is_new === true){
                 encargosSalvar = lancamentoEncargoArgs.owner.dataSource.data;
             }
             else{
                 encargosSalvar = lancamentoEncargoArgs.dataSource.filter(function(encargo){
                    return encargo.changed === true;
                });
             }

            Df11000_Lancamento_Service.salvaEncargo(encargosSalvar).then(function(){
                alteraStatusNotafiscal(lancamentoEncargoArgs.owner);
                encargosSalvar.forEach(function(encargo){
                    encargo.__is_new = false;
                    //@todo remover delete encargo.changed quando desmarcaLinhasEditadas for implementada
                    delete encargo.changed_VRITEMENCA;
                    delete encargo.changed;
                });
                Df11000_Lancamento_Service.setDataSourceEncargo(lancamentoEncargoArgs.dataSource).then(function(){
                    Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                        //@todo desmarcaLinhasEditadas
                        //GerUtil.desmarcaLinhasEditadas(lancamentoEncargoWidget, CANCELAR);
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        lancamentoEncargoArgs.owner.view();
                        lancamentoEncargoArgs.owner.reload();
                        controlaStatusWidgets(lancamentoEncargoArgs.owner.getParent(), lancamentoEncargoArgs.owner.name, true);
                    });
                });
            }, requestError);
         }
    };

    this.cancelaEncargoInlineEdit = function(lancamentoEncargoWidget) {
         //GerUtil.desmarcaLinhasEditadas(lancamentoEncargoWidget, CANCELAR);
         //delete encargo["changed_VRITEMENCA"];
         //delete encargo.changed;
        lancamentoEncargoWidget.dataSource.data.forEach(function(encargo){
            delete encargo.changed_VRITEMENCA;
            delete encargo.changed;
        });
        lancamentoEncargoWidget.view();
        controlaStatusWidgets(lancamentoEncargoWidget.getParent(), lancamentoEncargoWidget.name, true);
    };

    /* this.validaEncargoWizardBeforeNextStage = function(lancamentoSaidaEncargoArgs) {
    //     /* Remover todas acões relacionadas a variavel "nextStage" quando o processo de
    //      * "WizardBeforeNextStage, WizardAfterNextStage" se tornar síncrono
    //      * /
    //     if (!nextStage) {
    //         lancamentoSaidaEncargoArgs.e.preventDefault();

    //         LancamentoNFSaidaEncargoService.validaEncargoMaiorQuantItens().then(function() {
    //             nextStage = true;
    //             wizardEngine.next().then(function() {
    //                 nextStage = false;
    //             });
    //         }, function(error) {
    //             ScreenService.showMessage(error);
    //         });
    //     }
    // }; */
    
    const modificaDatasourceFilterProdutoServico = action => {
        const field = action.widget.getField('NMPRODUTO');

        field.dataSourceFilter = field.dataSourceFilter.filter(filter => filter.name != 'CDCLIENTE');

        if(action.name === 'novoServico'){
            field.dataSource.name = 'df_saida#/crud/servclie_servico_produto';

            const cliente = action.widget.getParent().currentRow.CDCLIENTE;
            const filterCdcliente = {
                name: 'CDCLIENTE',
                operator: '=',
                value: cliente
            };

            field.dataSourceFilter = [...field.dataSourceFilter, filterCdcliente];
            field.fields[0].isVisible = false;
            field.fields[1].isVisible = false;
            field.fields[2].isVisible = true;
            field.fields[3].isVisible = true;
            
            field.displayedFields       =  ["CDSERVFILI", "NMSERVICO"];
            field.searchableFields      =  ["CDSERVFILI", "NMSERVICO"];
            delete field.outData.NMPRODUTO;
            field.outData.NMSERVICO     = ['NMPRODUTO', 'NMSERVICO'];
            field.descriptionField      = 'NMSERVICO';
        } else if(action.name === 'novoItem') {
            this.verificaDataSourceProduto(field);
            field.fields[0].isVisible = true;
            field.fields[1].isVisible = true;
            field.fields[2].isVisible = false;
            field.fields[3].isVisible = false;
            field.displayedFields       =  ["CDARVPROD", "NMPRODUTO"];
            field.searchableFields =  ["CDARVPROD", "NMPRODUTO"];
            delete field.outData.NMPRODUTO;
            field.outData.NMPRODUTO     = 'NMPRODUTO';
            field.descriptionField  = 'NMPRODUTO';
        }

        field.dataSource.data = [];
        field.reload();

        return field.dataSource.name;
    };

    var verificaTipoItemProdutoServico = function(widget){
        if(widget.getParent().currentRow.IDOPERDEVONF !== "S"){
            if(widget.getParent().appliedFilter.FILTER_ROW.IDBLOQITNFAPUR !== "S"){
                if(widget.getField("NMPRODUTO").dataSource.name === "df#/produtoLancamento"){
                    widget.getAction("novoItem").isVisible = true;
                    widget.getAction("novoServico").isVisible = false;

                }
                else{
                    widget.getAction("novoItem").isVisible = false;
                    widget.getAction("novoServico").isVisible = true;
                }
            }
            else{
                widget.getAction("novoItem").isVisible = true;
                widget.getAction("novoServico").isVisible = false;
            }
        }
    };

    this.actNovoItemOnClick = function(args) {
        var itemWidget = args.owner.widget;
        var parentWidget = itemWidget.getParent();
        var dataSourceName = modificaDatasourceFilterProdutoServico(args.owner);

        var filter = [
            {
                'name': 'CDFILIAL', 
                'operator': '=', 
                'value': args.owner.widget.getParent().currentRow.CDFILIEMIT
            }
        ];
        
        General.callRestEngine('df#/crud/paramfilial', 'FilterData', filter).then(function(params){
            if((params.dataset.paramfilial[0].IDPERPROINAT == 'N') || (params.dataset.paramfilial[0].IDPERPROINAT == null)){
                var idproativpr = 
                {
                    "name": "IDPRODATIVPR",
                    "operator": "=",
                    "value": "S"
                };
                var idproatv = 
                {
                    "name": "IDPRODATIV",
                    "operator": "=",
                    "value": "A" 
                };
                //templateManager.container.getWidget('itens').getField('NMPRODUTO').dataSourceFilter.push(idproativpr);
                //templateManager.container.getWidget('itens').getField('NMPRODUTO').dataSourceFilter.push(idproatv);
            }/* else{
                var dataSourceFilter = templateManager.container.getWidget('itens').getField('NMPRODUTO').dataSourceFilter;
                if(dataSourceFilter.length > 2){
                    dataSourceFilter.pop();
                    dataSourceFilter.pop();
                }
            }*/
        });
        
        if(dataSourceName === "df_saida#/crud/servclie_servico_produto") {
            var controlaMaxItens = parentWidget.currentRow.IDCONMAXITEM;
            var numMaxServicos = parentWidget.currentRow.NRMAXITNF;
            if(controlaMaxItens != "N" && args.owner.widget.dataSource.data.length >= numMaxServicos)
                return ScreenService.showMessage("Foi alcançada a quantidade máxima de serviços no lançamento");
            itemWidget.label = 'Serviços';
        }

        itemWidget.newRow();
        Df11000_Lancamento_Service.getProxSeqItens().then(function(nrseqitprod){
            itemWidget.currentRow.NRSEQITPROD = nrseqitprod;
            controlaStatusWidgets(itemWidget, itemWidget.name, false);
        });
        General.justInteger('#NRSEQPEDPROD');

    };
    
    this.vencimentoWidgetAfterLoadDataSource = function(){
        var vencimentoWidget = templateManager.container.getWidget('vencimentos');
        
        if(vencimentoWidget.dataSource.data.length == 0){
            vencimentoWidget.dataSource.reload();
        }
    };

    var habilitaCamposCabecalhoNotaOrigem = function(cabecalhoWidget, lancamentoCabecalhoRow){
        var verificaUtilizaNotaOrigem = lancamentoCabecalhoRow.IDOPERDEVONF === "S";
        var serieOrigem = cabecalhoWidget.getField("CDSERIEORIGEM");
        var notaOrigem = cabecalhoWidget.getField("DSNOTAORIGEM");

        if(verificaUtilizaNotaOrigem){
            serieOrigem.required = true;
            notaOrigem.required = true;
            serieOrigem.isVisible = true;
            serieOrigem.readOnly = true;
            notaOrigem.isVisible = true;
        }
        else
        {
            delete serieOrigem.required;
            delete notaOrigem.required;
            serieOrigem.isVisible = false;
            notaOrigem.isVisible = false;
        }
    };

    var habilitaCamposItemNotaOrigem = function(lancamentoItensWidget, lancamentoCabecalhoRow) {
        var isNFComplemento = lancamentoCabecalhoRow.CDTIPOOPER == "03";
        var verificaUtilizaNotaOrigem = lancamentoCabecalhoRow.IDOPERDEVONF === "S" && !isNFComplemento;

        lancamentoItensWidget.getField('QTITEMORIG').isVisible = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('VRUNITITEM').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('VRDESCITEM').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('NMPRODUTO').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('CDPRODEMIS').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('DSPRODEMIS').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('VRTOTAITEM').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('DSINFADICPROD').readOnly = verificaUtilizaNotaOrigem;

        if(lancamentoCabecalhoRow.IDSTATUS !== "A" && lancamentoCabecalhoRow.IDSTATUS !== "C"){
            lancamentoItensWidget.getAction('novoItem').isVisible = !verificaUtilizaNotaOrigem;
            lancamentoItensWidget.getAction('excluirItem').isVisible = !verificaUtilizaNotaOrigem;
        }

        //if (verificaUtilizaNotaOrigem) {
        //    lancamentoItensWidget.getField('QTITEMPRODORIG').class = 4;
        //    lancamentoItensWidget.getField('QTITEMPROD').class = 4;
        //    lancamentoItensWidget.getField('VRUNITITEM').class = 4;
        //} else {
        //    lancamentoItensWidget.getField('QTITEMPRODORIG').class = 12;
        //    lancamentoItensWidget.getField('QTITEMPROD').class = 6;
        //    lancamentoItensWidget.getField('VRUNITITEM').class = 6;
        //}
    };

    this.actCancelarEdicaoItem = function(args){
        General.backOrCancel(args);
        var widget = args.owner.widget;
        widget.reload();
        let servicos = false; 
        widget.label = 'Produtos';
        controlaStatusWidgets(args.owner.widget, args.owner.widget.name, true);
    };

    this.actIncluirItemOnClick = function(lancamentoItemArgs) {
        lancamentoItemArgs.owner.widget.label = 'Produtos';
         if (lancamentoItemArgs.owner.widget.isValid()) {
             lancamentoItemArgs.row.NRLANCTONF = lancamentoItemArgs.owner.widget.getParent().currentRow.NRLANCTONF;
             lancamentoItemArgs.row.CDFILIAL = lancamentoItemArgs.owner.widget.getParent().currentRow.CDFILIAL;
             lancamentoItemArgs.row.IDATUVRESTOQ = 'S';
             lancamentoItemArgs.row.VRCONTITEM = '0';
             lancamentoItemArgs.row.IDCONFORITEM = 'S';
             lancamentoItemArgs.row.VRBRUTITEM = '0';
             if(!lancamentoItemArgs.row.VRDESCITEM){
                 lancamentoItemArgs.row.VRDESCITEM = '0';
             }

             if(Df11000_Lancamento_Service.verificaUtilizaNotaOrigem(lancamentoItemArgs.owner.widget.getParent().currentRow) && lancamentoItemArgs.row.QTITEMPROD === "0" && lancamentoItemArgs.row.__is_new === false){
                 Df11000_Lancamento_Service.excluiItem(lancamentoItemArgs.row).then(function() {
                     lancamentoItemArgs.row.__is_new = true;
                     Df11000_Lancamento_Service.setDataSourceItem(lancamentoItemArgs.row).then(function () {
                         Df11000_Lancamento_Service.atualizaLancamento().then(function () {
                             Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                             lancamentoItemArgs.owner.widget.view();
                             //General.backOrCancel(lancamentoItemArgs);
                             lancamentoItemArgs.owner.widget.reload();
                             controlaStatusWidgets(lancamentoItemArgs.owner.widget, lancamentoItemArgs.owner.widget.name, true);
                         });
                     });
                 }, requestError);
             }
             else{
                 Df11000_Lancamento_Service.salvaItem(lancamentoItemArgs.owner.widget.getParent().currentRow, lancamentoItemArgs.row).then(function(){
                     alteraStatusNotafiscal(lancamentoItemArgs.owner.widget);
                     lancamentoItemArgs.row.__is_new = false;
                     verificaTipoItemProdutoServico(lancamentoItemArgs.owner.widget);
                     Df11000_Lancamento_Service.setDataSourceItem(lancamentoItemArgs.row).then(function(){
                         Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                             Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                             lancamentoItemArgs.owner.widget.view();
                             
                             lancamentoItemArgs.owner.widget.reload();
                             controlaStatusWidgets(lancamentoItemArgs.owner.widget, lancamentoItemArgs.owner.widget.name, true);
                         });
                     });
                 }, function(error) {
                    if (Array.isArray(error)) {
                        var stringCamposObrig = error.join(', ');
                        var mensagem = "CAMPOS_MAIORES_ZERO";
                        MessageService.showMessageByCode(mensagem, {"PARAMETRO": stringCamposObrig});
                    } else if (typeof error === 'string')
                        ScreenService.showMessage(error);
                    if(error.data)
                        ScreenService.showMessage(error.data.error);
                });
             }
         }
    };

    this.actEditarItemOnClick = function(detalhesItemWidget) {
        if(Df11000_Lancamento_Service.verificaUtilizaNotaOrigem(detalhesItemWidget.getParent().currentRow)){
            Df11000_Lancamento_Service.buscaQuantidadeDevolvida(detalhesItemWidget.getParent().currentRow, detalhesItemWidget).then(function(data) {
                detalhesItemWidget.currentRow.QTITEMDEVO = data.length !== 0 ? data[0].QTITEMDEVO : "0";
                detalhesItemWidget.currentRow.QTITEMPRODBEFOREEDIT = detalhesItemWidget.currentRow.QTITEMPROD;
                General.edit(detalhesItemWidget);
            }, function(error) {
                if (!!error)
                    ScreenService.showMessage('Ocorreu um erro ao buscar a quantidade de itens disponíveis.' + error.data.error);
            });
        }
        else{
            General.edit(detalhesItemWidget);
        }
        General.justInteger('#NRSEQPEDPROD');
    };

    this.actExcluirItemOnClick = function(lancamentoItemArgs) {
        ScreenService.confirmMessage('Deseja excluir o item?', 'question', function (success) {
            Df11000_Lancamento_Service.excluiItem(lancamentoItemArgs.row).then(function(){
                alteraStatusNotafiscal(lancamentoItemArgs.owner.widget);
                Df11000_Lancamento_Service.excluiItemDataSource(lancamentoItemArgs.row.NRSEQITPROD).then(function(){
                    Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        General.backOrCancel(lancamentoItemArgs);
                        lancamentoItemArgs.owner.widget.reload().then(function(){
                            verificaTipoItemProdutoServico(lancamentoItemArgs.owner.widget);
                        });
                    });
                });
            }, requestError);
        });
    };

    var setValoresEmissaoProdutoOnChange = function(lancamentoItemArgs) {
        if(lancamentoItemArgs.row.CDSERVFILI) {
            General.callRestEngine("df#/crud/paramgeral", "FilterData", []).then(function(success) {
                var resul = success.dataset.paramgeral;
                if(resul[0].IDUTPROPEMIS == 'S') {
                    lancamentoItemArgs.row.CDPRODEMIS = lancamentoItemArgs.row.CDARVPROD;
                    lancamentoItemArgs.row.DSPRODEMIS = lancamentoItemArgs.row.NMPRODUTO;
                }
                else {
                    lancamentoItemArgs.row.CDPRODEMIS = lancamentoItemArgs.row.CDSERVFILI;
                    if(lancamentoItemArgs.row.DSEMISSERCLI) {
                        lancamentoItemArgs.row.DSPRODEMIS = lancamentoItemArgs.row.DSEMISSERCLI;
                    }
                    else {
                        lancamentoItemArgs.row.DSPRODEMIS = lancamentoItemArgs.row.NMSERVICO;
                    }
                }
            });
        }
        else {
            lancamentoItemArgs.row.CDPRODEMIS = lancamentoItemArgs.row.CDARVPROD;
            lancamentoItemArgs.row.DSPRODEMIS = lancamentoItemArgs.row.NMPRODUTO;
        }
    };
    
    var consultaCustoQuantidadeProdutoOnChange = function(lancamentoItemArgs) {
         var filial = lancamentoItemArgs.owner.field.widget.getParent().currentRow.CDFILIEMIT;
         var dtLancamento = lancamentoItemArgs.owner.field.widget.getParent().currentRow.DTENTRSAID;
         var produto = lancamentoItemArgs.row.CDPRODUTO;
         var operacao = lancamentoItemArgs.owner.field.widget.getParent().currentRow.CDTIPOOPER;

         lancamentoItemArgs.row.VRUNITITEM = "";
         lancamentoItemArgs.row.QTITEMPROD = "";
         lancamentoItemArgs.row.VRTOTAITEM = "";

        if (produto) {
            if(lancamentoItemArgs.row.CDSERVFILI) {
                lancamentoItemArgs.row.VRUNITITEM = lancamentoItemArgs.row.VRSERVFATU;
            }
            else {
                ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(filial, produto, dtLancamento, null , null, null, null, null , operacao).then(function(custoQuant) {
                    custoQuant = custoQuant.dataset.consultaCustoQuantidadeProduto.VRCUSTOPROD;
                    lancamentoItemArgs.row.VRUNITITEM = typeof(custoQuant) === "string" ? parseFloat(custoQuant) : custoQuant;
                }, requestError);
            }
        }
    };

    var informacoesComplementaresProduto = function(lancamentoItemArgs){
        var itensWidget = lancamentoItemArgs.owner.field.widget;
        
        var filter = [
            { "name": "CDTIPOOPER", "operator": "=", "value": getCabecalhoWidget().currentRow.CDTIPOOPER},
            {"name": "IDENTRSAIDOP", "operator": "=", "value":  "S"}
        ];
         
        lancamentoItemArgs.row.CDFILIMOVI = getCabecalhoWidget().currentRow.CDFILIEMIT;
      
        General.callRestEngine("df#/crud/tipooperac", "FilterData", filter).then((success) => {
            
            atualizaEstoque = success.dataset.tipooperac[0].IDATUESTTPOP;
            itensWidget.paramInfoCompl.DocuDevo =  getCabecalhoWidget().currentRow.IDOPERDEVONF == 'S';
            itensWidget.paramInfoCompl.AtuEstoq = atualizaEstoque == 'S';
        
            Lib00206_InfComplProduto_Controller.infComplementares(itensWidget, lancamentoItemArgs.row, false, atualizaEstoque);
        });

    };

    this.validacoesProdutoOnChange = function(lancamentoItemArgs) {
        if(getCabecalhoWidget().currentRow.IDNFAJUSTE != 'S' && getCabecalhoWidget().currentRow.CDTIPOOPER != '03') 
            informacoesComplementaresProduto(lancamentoItemArgs);
        setValoresEmissaoProdutoOnChange(lancamentoItemArgs);
        consultaCustoQuantidadeProdutoOnChange(lancamentoItemArgs);
    };

    this.afterCancelInfoCompl = function(args){
        args.owner.widget = args.owner;
        this.actCancelarEdicaoItem(args);
    };

    var calculaValorTotal = function(lancamentoItemArgs) {
        if(Df11000_Lancamento_Service.verificaUtilizaNotaOrigem(getCabecalhoWidget().currentRow) && lancamentoItemArgs.row.QTITEMPROD === "0"){
            lancamentoItemArgs.row.VRTOTAITEM = lancamentoItemArgs.row.VRUNITITEM;
        }
        else{
            lancamentoItemArgs.row.VRTOTAITEM = Df11000_Lancamento_Service.calculaValorTotal(
                lancamentoItemArgs.row.QTITEMPROD, lancamentoItemArgs.row.VRUNITITEM
            );
        }
    };

    this.valorUnitarioFieldOnChange = function(lancamentoItemArgs) {
         lancamentoItemArgs.row.VRUNITITEM =  typeof(lancamentoItemArgs.row.VRUNITITEM) === "string" ? parseFloat(lancamentoItemArgs.row.VRUNITITEM.replace(/[.]+/g, '').replace("," , ".")): lancamentoItemArgs.row.VRUNITITEM;
         calculaValorTotal(lancamentoItemArgs);
    };

    this.quantidadeFieldOnChange = function(lancamentoItemArgs) {
        /* Se QTESTOQDIA não exister na row significa que a "Informações Complementares de Produto" não foi aberta
        porntanto, trat-ase de um produto que não controla estoque ou a operação está sendo feita com uma filial
        que não controla estoque, logo a validação de quantidade não deve ser feita. */
        if(lancamentoItemArgs.row.QTESTOQDIA && parseFloat(lancamentoItemArgs.row.QTITEMPROD * lancamentoItemArgs.row.VRFATOCONV) > lancamentoItemArgs.row.QTESTOQDIA) {
            MessageService.showMessageByCode("QUANTIDADE_ESTOQUE",{"QTESTOQDIA": parseFloat(lancamentoItemArgs.row.QTESTOQDIA), "SGUNIDADE": parseFloat(lancamentoItemArgs.row.SGUNIDADE)});
            lancamentoItemArgs.row.QTITEMPROD = 0.00;
        }
        else{
           
            lancamentoItemArgs.row.QTITEMPROD =  typeof(lancamentoItemArgs.row.QTITEMPROD) === "string" ? parseFloat(lancamentoItemArgs.row.QTITEMPROD.replace(/[.]+/g, '').replace("," , ".")): lancamentoItemArgs.row.QTITEMPROD;
            calculaValorTotal(lancamentoItemArgs);
        } 
    };

    this.valorTotalFieldOnChange = function(lancamentoItemArgs) {
         lancamentoItemArgs.row.VRUNITITEM = Df11000_Lancamento_Service.calculaValorUnitario(
             lancamentoItemArgs.row.QTITEMPROD, lancamentoItemArgs.row.VRTOTAITEM
         );
    };

    var buscaItensNotaOrigem = false;

    this.setDtsItensNotaOrigemOnEnter = function(lancamentoItensArgs) {

        if((buscaItensNotaOrigem && Df11000_Lancamento_Service.verificaUtilizaNotaOrigem(lancamentoItensArgs.owner.getParent().currentRow))){
            Df11000_Lancamento_Service.buscaItensNotaOrigem(lancamentoItensArgs.owner.getParent().currentRow).then(function(itens) {
                itens.forEach(function(item){
                    var itemJaSalvo = lancamentoItensArgs.owner.dataSource.data.filter(function(data){
                        if(data.NRSEQITPROD === item.NRSEQITPROD)
                            data.QTITEMORIG = item.QTITEMORIG;
                        return data.NRSEQITPROD === item.NRSEQITPROD;
                    });
                    if(itemJaSalvo.length > 0){
                        var index = itens.indexOf(item);
                        itens.splice(index, 1);
                    }
                    else{
                        item.__is_new = true;
                        lancamentoItensArgs.owner.dataSource.data.push(item);
                    }
                });
                buscaItensNotaOrigem = false;
                if(lancamentoItensArgs.owner.getParent().currentRow.IDSTATUS === 'D') {
                    Df11000_Lancamento_Service.setDataSourceItem(itens).then(() => {
                        Df11000_Lancamento_Service.atualizaLancamento().then(lancamentoItensArgs.owner.reload());
                    });
                }
                
            }, function(error) {
                lancamentoItensArgs.owner.reload();
            });
        }
        
    };

    this.actNovoVencimentoOnClick = function(args) {
        args.owner.widget.newRow();
        Dfs11000_LancamentoSaida_Service.getProxSeqVencimento().then(function(nrseqvenrec){
            args.owner.widget.currentRow.NRSEQVENREC = nrseqvenrec;
        });
        setMinMaxDateVencimento(args.owner.widget);
    };

    this.actEditarVencimentoOnClick = function(detalhesVencimentoWidget) {
        setMinMaxDateVencimento(detalhesVencimentoWidget);
        General.edit(detalhesVencimentoWidget);
    };

    var setMinMaxDateVencimento = function(widget) {
        var parentCurrentRow = widget.getParent().currentRow;
        var parentDate = moment(parentCurrentRow.DTENTRSAID, "DD/MM/YYYY");
        var dateField = widget.getField("DTATUAVENREC");
        dateField.minDate = parentDate.format("DD/MM/YYYY");
        dateField.maxDate = parentDate.add(60, "days").format("DD/MM/YYYY");
    };

    this.actIncluirVencimentoOnClick = function(lancamentoVencimentoArgs) {
         if (lancamentoVencimentoArgs.owner.widget.isValid()) {
            var dataLancamento = lancamentoVencimentoArgs.owner.widget.getParent().currentRow.DTENTRSAID;
            var dataVencimento = lancamentoVencimentoArgs.row.DTATUAVENREC;
            var dataProcessamento = getLocalVar('DATA_PROCESSAMENTO');
            var erroDataVencimento = Df11000_Lancamento_Service.validaDataVencimento(dataLancamento, dataVencimento, dataProcessamento);

            if (erroDataVencimento)
                return ScreenService.showMessage(erroDataVencimento);

            lancamentoVencimentoArgs.row.NRLANCTONF = lancamentoVencimentoArgs.owner.widget.getParent().currentRow.NRLANCTONF;
            lancamentoVencimentoArgs.row.CDFILIAL = lancamentoVencimentoArgs.owner.widget.getParent().currentRow.CDFILIAL;
            lancamentoVencimentoArgs.row.NRPARCELAREC = '00';
            lancamentoVencimentoArgs.row.VRORIGREC = lancamentoVencimentoArgs.row.VRATUAREC;
            lancamentoVencimentoArgs.row.DTORIGVENREC = lancamentoVencimentoArgs.row.DTATUAVENREC;

            Dfs11000_LancamentoSaida_Service.salvaVencimento(lancamentoVencimentoArgs.row).then(function() {
                alteraStatusNotafiscal(lancamentoVencimentoArgs.owner.widget);
                var closeSwipe = lancamentoVencimentoArgs.row.__is_new === true;
                //@todo remover __is_new quando widget.edit() funcionar
                lancamentoVencimentoArgs.row.__is_new = false;
                Df11000_Lancamento_Service.setDataSourceVencimento(lancamentoVencimentoArgs.row).then(function(){
                    Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        lancamentoVencimentoArgs.owner.widget.view();
                        if(closeSwipe)
                            ScreenService.closeSwipe();
                        lancamentoVencimentoArgs.owner.widget.reload();
                    });
                });
            }, requestError);
         }
    };

    this.actExcluirVencimentoOnClick = function(lancamentoVencimentoArgs) {
        ScreenService.confirmMessage('Deseja excluir o vencimento?', 'question', function (success) {
            Dfs11000_LancamentoSaida_Service.excluiVencimento(lancamentoVencimentoArgs.row).then(function () {
                alteraStatusNotafiscal(lancamentoVencimentoArgs.owner.widget);
                Df11000_Lancamento_Service.excluiVencimentoDataSource(lancamentoVencimentoArgs.row.NRSEQVENREC).then(function () {
                    Df11000_Lancamento_Service.atualizaLancamento().then(function () {
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        General.backOrCancel(lancamentoVencimentoArgs);
                        lancamentoVencimentoArgs.owner.widget.reload();
                    });
                });
            }, requestError);
        });
    };

    this.validaUtilizaVencimentoWidgetOnEnter = function(vencimentoSaidaArgs) {
        if(vencimentoSaidaArgs.owner.getParent().currentRow.IDSTATUS !== "A" || vencimentoSaidaArgs.owner.getParent().currentRow.IDSTATUS !== "C"){
            //@todo isVisible || readonly
            vencimentoSaidaArgs.owner.getAction('actNovoVencimento').isVisible = (vencimentoSaidaArgs.owner.getParent().currentRow.IDUTILVENC === 'S');
            validaEdicaoNota();
        }
    };

    this.fecharNota = function(args) {
        var row, forcaFechamento;
        
        var cabecalhoWidget = templateManager.container.getWidget('cabecalho');
        
        cabecalhoWidget.reload();
        
        if(args) {
            if(args.owner.getParent().name == 'cabecalho') var popup = true;
            row = args.row;
            forcaFechamento = false;
        } else{
            row = cabecalhoWidget.currentRow;
            forcaFechamento = true;
        }
        
        ScreenService.confirmMessage('Deseja fechar a nota fiscal?', 'question', function (success) {
            
            Df11000_Lancamento_Service.fecharNota(getCabecalhoWidget().currentRow, forcaFechamento).then(function(callback) {
                Df11000_Lancamento_Service.geraRateio();
                if (callback) {
                    if(callback.dataset.fecharNota.ERROS_REPLICACAO){
                        ErrosReplicacaoDocumentos_Utilities.errosReplicacao(args.owner.widget, callback.dataset.fecharNota.ERROS_REPLICACAO);
                        ScreenService.showMessage("Ocorreram erros ao tentar realizar a replicação da nota fiscal.");
                    }
                    else{
                        ScreenService.goBack();
                        var parentWidget = getCabecalhoWidget();
                        parentWidget.currentRow.IDSTATUS = 'P';
                        parentWidget.currentRow.VRNOTAFISC = callback.dataset.fecharNota.CABECALHO.VRNOTAFISC;
                        parentWidget.reload();
                        ScreenService.successNotification("Nota fechada com sucesso!");
                        if(popup) ScreenService.closePopup();
                    
                    }
                }
                else {
                    ScreenService.showMessage("TIMEOUT <br> Ocorreu algum erro interno no servidor. Por favor realize a operação novamente.");
                }
            }, 
            (error) => {
                if(popup) ScreenService.closePopup();
                var errosAvisos = templateManager.container.getWidget('errosAvisos');
                var bloqueia   = false;
                errosAvisos.dataSource.data = error.data.dataset.errosFechamento;
                error.data.dataset.errosFechamento.forEach((erro) => {
                    if(erro.IDERROAVISO == 'B') bloqueia = true;
                });
                errosAvisos.isVisible = true;
                errosAvisos.getAction('confirmarFechamento').isVisible = !bloqueia;
                ScreenService.openPopup(errosAvisos);
                
                ScreenService.showMessage(error.data.error);
            });

        });

            
    };

    this.nivelCompletoProduto = function(){
        return General.getLevelByMask('GER_CDPICTPROD','1').length;
    };
    
   /* this.getFieldFromFilterPopup = function(field, preference){
        
        var container =  templateManager.container;
        if(container) {
            var cabecalhoWidget = getCabecalhoWidget();
            if(cabecalhoWidget && cabecalhoWidget.appliedFilter)
                return cabecalhoWidget.appliedFilter.FILTER_ROW.field || 'TD';
        }
    };*/
    
    this.getFiltroCDFILIEMIT = function () {
        return CDFILIEMIT;
    };
    
    
    this.getFieldFromFilterPopup = function(filedName, widgetName) {
        var container =  templateManager.container;
        if(container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
              filterWidget = filterBforeApply;
            else {
                var f = container.getWidget(widgetName);
                if(f) {
                     filterWidget = container.getWidget(widgetName).appliedFilter;
                }
               
            }
            
            if(filterWidget) {
                var valueField;
                if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[filedName];
                else
                    valueField = filterWidget.FILTER_ROW[filedName];
                    
                return valueField || 'TD';
            }
            else return null;
        }
        else return null;
    };

    this.criaDataSourceFilterAfterApply = function(args) {
        var cabecalhoWidget = args.owner;
        var dataSourceFilter = cabecalhoWidget.dataSourceFilter;
        var currentRowPopup = cabecalhoWidget.appliedFilter.FILTER_ROW;
        var camposData = ['P_DTENTRSAIDINI', 'P_DTENTRSAIDFIM', 'P_DTEMISSAOINI', 'P_DTEMISSAOFIM'];
        var datasRemover = dataSourceFilter.filter(function(field){
            return camposData.indexOf(field.name) >= 0;
        });
        if(datasRemover && datasRemover.length >= 0){
            datasRemover.forEach(function(data){
                dataSourceFilter.splice(dataSourceFilter.indexOf(data), 1);
            });
        }
        var datasFiltro = dataSourceFilter.filter(function(value) {
            return value.name === "DTENTRSAID" || value.name === 'DTEMISSAO';
        });
        if(datasFiltro.length === 1){
            var dataEmissao = {
                "name": "DTEMISSAO",
                "value": {
                    0: "TD", 1: "TD"
                }
            };
            datasFiltro.push(dataEmissao);
        }
        var filterDefault = {
            'operator': '='
        };
        datasFiltro.forEach(function(data) {
            filterDefault.name = 'P_' + data.name + 'INI';
            filterDefault.value = (data.value[0] != 'TD') ? data.value[0] : '';
            dataSourceFilter.push(Util.clone(filterDefault));
            filterDefault.name = 'P_' + data.name + 'FIM';
            filterDefault.value = (data.value[1] != 'TD') ? data.value[1] : '';
            dataSourceFilter.push(Util.clone(filterDefault));
            if(data.name == 'DTEMISSAO') {
                if(data.value[0] == 'TD') {
                    filterDefault.name = 'P_TDTEMISSAO';
                    filterDefault.value = 'TD';
                    dataSourceFilter.push(Util.clone(filterDefault));
                }
                else {
                    filterDefault.name = 'P_TDTEMISSAO';
                    filterDefault.value = '';
                    dataSourceFilter.push(Util.clone(filterDefault));
                }
            }
            if(dataSourceFilter.indexOf(data) > 0)
                dataSourceFilter.splice(dataSourceFilter.indexOf(data), 1);
        });
        
        cabecalhoWidget.dataSourceFilter = cabecalhoWidget.dataSourceFilter.filter(function(field){return field.name[1] == '_';});
        let filterCDTIPOOPER = this.getFieldFromFilterPopup('CDTIPOOPER');
        if(filterCDTIPOOPER.length && filterCDTIPOOPER != 'TD')
            cabecalhoWidget.dataSourceFilter.push({operator: "IN", name: "CDTIPOOPER", value: "@Dfs11000_LancamentoSaida_Controller.getFieldFromFilterPopup('CDTIPOOPER')@"});
        
        cabecalhoWidget.reload();
    };
    
     //----------------------------------- DFS11300 Replicação de Documentos ---------------------------------------------------//
    
    this.openReplicacaoExclusao = function(args) {
        var widgetPopup = templateManager.container.getWidget('EXCLUSAONOTAREPLICADA');
        widgetPopup.cabecalhoArgs = args;
        widgetPopup.dataSourceFilter[0].value = args.row.CDFILIAL.concat(args.row.NRLANCTONF);
        widgetPopup.isVisible = true;
        widgetPopup.activate();
        widgetPopup.edit();
        ScreenService.openPopup(widgetPopup);
        widgetPopup.reload();
    };
    
    this.closeExclusao = function(widgetPopup) {
        var widget = templateManager.container.getWidget('cabecalho');
        ScreenService.closePopup(widgetPopup);
        widget.list();
        widget.activate();
        widget.reload();
    };
    
    /**
     * Valida a widget e abre a widget
     * de replicação.
     * 
     * @param {object} widget widget de 
     * uma nota fiscal.
    */
    this.openReplicacao = function(parentWidget) {
        if(parentWidget.currentRow.CDFILIRECE && parentWidget.currentRow.CDFILIEMIT) {
            //var length = parentWidget.widgets.length;
            var widget = templateManager.container.getWidget('REPLICACAODOCUMENTOS');
            ScreenService.closePopup();
            //var widget = parentWidget.widgets[length-2];
            var widgetFilha = widget.widgets[0];
            
            changeWidgetAcessibility([...parentWidget.widgets, widget], false);
            
            widget.activate();
            widget.showAsTab = true;
            parentWidget.openTab('REPLICACAODOCUMENTOS');
            
            
            widget.fields[1].reload();
            widget.reload();
            widget.edit();
            
            
            widgetFilha.edit();
            widgetFilha.actions[0].isVisible = true;
            widgetFilha.actions[1].isVisible = true;
            widgetFilha.actions[4].isVisible = false;
            widgetFilha.actions[5].isVisible = false;
            widgetFilha.reload();
        }
        else {
            ScreenService.showMessage("Replicação indisponivel para esta nota.");
        }
    };
    
    /**
     * Altera a acessibildiade da widget.
     * 
     * @param {array} widgets widgets
     * do cabecalho.
    */
	function changeWidgetAcessibility(widgets, enabled) {
		widgets.forEach(function (widget) {
			if(widget.name !== 'REPLICACAODOCUMENTOS') widget.enabled = enabled;
			else widget.enabled = !enabled;
		});
        widgets[0].getParent().enabled = enabled;
		templateManager.updateTemplate();
	}
    
    this.produtosOnEnter = function(widget, tabName, args, preference) {

        // close replicacao
        if(widget.showAsTab == true) {
            widget.showAsTab = false;
            widget.reload();
            widget.currentRow = {};
            widget.widgets[0].currentRow = {};
            widget.widgets[0].reload();
            widget.getParent().activate();
            widget.getParent().reload().then(() => {
                this.setDtsItensNotaOrigemOnEnter(args, preference);
            });
            changeWidgetAcessibility([...widget.getParent().widgets, widget], true);
            if(widget.getParent().openTab) widget.getParent().openTab(tabName);
        }
        else {
            this.setDtsItensNotaOrigemOnEnter(args, preference);
        }
        
        //muda a visibilidade da ação de adicionar item de acordo com o status NFE
        alteraVisibilidadeActionsProduto();
    };
    
    /**
     * Cancela uma replicação.
     * 
     * @param {object} widget widget
     * de replicação.
    */
    this.closeReplicacao = function(widget, tabName) {
        if(widget.showAsTab == true) {
            widget.showAsTab = false;
            widget.reload();
            widget.currentRow = {};
            widget.widgets[0].currentRow = {};
            widget.widgets[0].reload();
            widget.getParent().activate();
            widget.getParent().reload();
            changeWidgetAcessibility([...widget.getParent().widgets, widget], true);
            if(widget.getParent().openTab) widget.getParent().openTab(tabName);
        } 
    };
    
    /**
     * Replica o documento.
     * 
     * @param {object} widget popup da replicação de 
     * documentos.
    */
    this.replicardocumento = function(widget) {
        var notafiscal = widget.getParent().getParent().currentRow;
        var erro = false;
        widget.dataSource.data.forEach(function(data) {
            if((data.CDFILIORIGRD !== notafiscal.CDFILIEMIT || data.CDFILIDESTRD !== notafiscal.CDFILIRECE) && data.IDENTRSAIDOP === 'E') erro = true;
        });
        if(erro) ScreenService.showMessage("Para toda entrada a ser gerada deve ser informada uma saída.");
        else {
            var dataset = [
                notafiscal,
                widget.getParent().currentRow,
                widget.dataSource.data
            ];
            Dfs11000_LancamentoSaida_Service.replicarDocumento(dataset).then(function(callback) {
                if(callback.dataset.replicacaoManual.ERROS_REPLICACAO){
                    
                    ErrosReplicacaoDocumentos_Utilities.errosReplicacao(widget, callback.dataset.replicacaoManual.ERROS_REPLICACAO);
                    ScreenService.showMessage("Ocorreram erros ao tentar realizar a replicação da nota fiscal.");
                }
                else {
                    ScreenService.showMessage("Replicação de documentos realizada com sucesso.");
                    this.closeReplicacao(widget.getParent(), 'cabecalho');
                }
            }.bind(this));
        }
    };
    
    /**
     * Carrega a widget de documentos e
     * altera o funcionamento para localStorage.
     * 
     * @param {object} widget widget de 
     * documentos gerados.
    */
    this.reloadDocumentos = function(widgetPai) {
        var widget = widgetPai.widgets[0];
        widget.dataSource.rest = true;
        widget.dataSource.localStorage = false;
        widget.reload().then(function(success) {
            localStorageEngine.setDataSource(widget.dataSource.name, widget.dataSource.data);
            widget.dataSource.rest = false;
            widget.dataSource.localStorage = true;
        });
    };
    
    /**
     * Abre a edição de documento.
     * E altera o readOnly/field dos campos.
     * 
     * @param {object} widget widget de 
     * documentos gerados.
    */
    this.editDocReplic = function(widget) {
        widget.actions[0].isVisible = false;
        widget.actions[1].isVisible = false;
        widget.actions[4].isVisible = true;
        widget.actions[5].isVisible = true;
        General.edit(widget);
        var operacao = widget.getField('NMTIPOOPER');
        this.readOnlyAlmoxDocumento(widget);
        
        if(widget.currentRow.IDENTRSAIDOP) {
            this.changeFieldSerie(widget.getField('CDSERIE'), widget.currentRow.IDENTRSAIDOP);
            var cdfilial = (widget.currentRow.IDENTRSAIDOP == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
            var almoxarifado = widget.getField('DSALMOXARIFE');
            var localizacao  = widget.getField('DSLOCALESTOQ');
            widget.getField('CDSERIE').readOnly = false;
            operacao.readOnly = false;
            almoxarifado.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
            almoxarifado.outData.CDALMOXARIFE = (widget.currentRow.IDENTRSAIDOP == 'S') ? ["CDALMOXARIFE", "CDALMOORIGRD"] : ["CDALMOXARIFE", "CDALMODESTRD"];
            localizacao.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
        }
    };
    
    /**
     * Salva a edição de um documento
     * no localStorage.
     * 
     * @param {object} widget widget de 
     * documentos gerados.
    */
    this.saveDoc = function(widget) {
        var data = widget.dataSource.data;
        data[widget.currentRow.__index] = widget.currentRow;
        localStorageEngine.setDataSource(widget.dataSource.name, widget.dataSource.data);
        widget.redraw();
        ScreenService.goBack();
        widget.edit();
        widget.actions[0].isVisible = true;
        widget.actions[1].isVisible = true;
        widget.actions[4].isVisible = false;
        widget.actions[5].isVisible = false;
    };
    
    /**
     * Cancela a edição de um documento.
     * 
     * @param {object} widget widget de 
     * documentos gerados.
    */
    this.cancelEditDocReplic = function(widget) {
        widget.currentRow = widget.backupRow;
        ScreenService.goBack();
        widget.edit();
        widget.actions[0].isVisible = true;
        widget.actions[1].isVisible = true;
        widget.actions[4].isVisible = false;
        widget.actions[5].isVisible = false;
    };
    
    /**
     * Verifica se filial de origem e destino são iguais.
     * Altera o readOnly dos campos ligados
     * a filial(DSALMOXARIFE, CDSERIE).
     * 
     * @param {object} field field de filial (destino ou origem)
     * da widget documentos gerados.
    */
    this.onChangeFilialDocGerado = function(field) {
        var widget  = field.widget;
        var cdfilial = (field.name == 'NMFILIORIG') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
        var cdfilial2 = (field.name == 'NMFILIORIG') ? 'CDFILIDESTRD' : 'CDFILIORIGRD';
        var filialSerie = (widget.currentRow.IDENTRSAIDOP == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
        if(widget.currentRow[cdfilial] && widget.currentRow[cdfilial2]) {
            if(widget.currentRow[cdfilial] === widget.currentRow[cdfilial2]) {
                widget.currentRow[cdfilial] = '';
                widget.currentRow[field.name] = '';
                ScreenService.showMessage('Filial de destino e origem não podem ser iguais');
            }
            else {
                if(widget.currentRow.IDENTRSAIDOP === 'S') this.setFilterSerieSaida(widget.fields[5], widget.currentRow[cdfilial]);
            }
        }
        else if(widget.currentRow.IDENTRSAIDOP === 'S' && cdfilial === 'CDFILIORIGRD' && widget.currentRow[cdfilial]) {
            this.setFilterSerieSaida(widget.fields[3], widget.currentRow[cdfilial]);
        }
        if(widget.currentRow.IDENTRSAIDOP && widget.currentRow[filialSerie]) widget.getField('CDSERIE').readOnly = false;
        else widget.getField('CDSERIE').readOnly = true;
        this.readOnlyAlmoxDocumento(widget);
    };
    
    /**
     * Altera o readOnly e filtro dos campos ligados
     * ao tipo de operação(DSALMOXARIFE, DSLOCALESTOQ, NMTIPOOPER, CDSERIE).
     * 
     * @param {object} field field de IDENTRSAIDOP (destino ou origem)
     * da widget documentos gerados.
    */
    this.onChangeIdEntrSaidaOp = function(field) {
        var widget = field.widget;
        var cdfilial = (field.value() == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
        var operacao = widget.getField('NMTIPOOPER');
        var almoxarifado = widget.getField('DSALMOXARIFE');
        var localizacao  = widget.getField('DSLOCALESTOQ');
        if(!field.value()) {
            operacao.readOnly = true;
            almoxarifado.readOnly = true;
            localizacao.readOnly = true;
        }
        else {
            this.changeFieldSerie(widget.getField('CDSERIE'), field.value());
            if(widget.currentRow[cdfilial]) {
                widget.fields[3].readOnly = false;
                widget.currentRow.CDSERIE = '';
                if(field.value() === 'S') this.setFilterSerieSaida(widget.fields[3], widget.currentRow[cdfilial]);
                if(widget.currentRow.IDENTRSAIDOP && widget.currentRow[cdfilial]) widget.getField('CDSERIE').readOnly = false;
                else widget.getField('CDSERIE').readOnly = true;
                almoxarifado.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
                almoxarifado.outData.CDALMOXARIFE = (field.value() == 'S') ? ["CDALMOXARIFE", "CDALMOORIGRD"] : ["CDALMOXARIFE", "CDALMODESTRD"];
                localizacao.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
            }
            this.readOnlyAlmoxDocumento(widget);
            operacao.readOnly = false;
        }
        operacao.reload();
        almoxarifado.setValue('');
        widget.currentRow.CDALMOXARIFE = '';
        operacao.setValue('');
        widget.currentRow.CDTIPOOPER   = '';
        localizacao.setValue('');
        widget.currentRow.CDLOCALESTOQ = '';
    };
    
    /**
     * Altera o readOnly e do campo de almoxarifado('DSALMOXARIFE')
     * de acordo com a filial e o tipo de operação('E' ou 'S').
     * 
     * @param {object} widget  widget documentos gerados.
    */
    
    this.readOnlyAlmoxDocumento = function(widget) {
        var almoxarifado = widget.getField('DSALMOXARIFE');
        if(widget.currentRow.IDENTRSAIDOP) {
            var cdfilial = (widget.currentRow.IDENTRSAIDOP == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
            almoxarifado.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
            if(widget.currentRow[cdfilial]) {
                var filter = [
                    {
                        "name":"CDFILIAL",
                        "operator":"=",
                        "value": widget.currentRow[cdfilial]
                    }
                ];
                General.callRestEngine('df#/crud/paramfilial', 'FilterData', filter).then(function(success){
                    if(success.dataset.paramfilial[0].IDUTILALMOX === 'S') {
                        almoxarifado.readonly = false;
                        almoxarifado.reload();
                        this.readOnlyLocalDocumento(widget);
                    } 
                }.bind(this));
            }
            else almoxarifado.readOnly = true;
        }  
        else almoxarifado.readOnly = true;
    };
    
    /**
     * Altera o readOnly e do campo de localização('DSLOCALESTOQ') 
     * de acordo com a filial e o tipo de operação('E' ou 'S').
     * 
     * @param {object} widget  widget documentos gerados.
    */
    this.readOnlyLocalDocumento = function(widget) {
        var local = widget.getField('DSLOCALESTOQ');
        if(widget.currentRow.IDENTRSAIDOP) {
            var cdfilial = (widget.currentRow.IDENTRSAIDOP == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
            if(widget.currentRow[cdfilial] && widget.currentRow.CDALMOXARIFE) {
                local.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
                var filter = [
                    {
                        "name":"CDFILIAL",
                        "operator":"=",
                        "value": widget.currentRow[cdfilial]
                    }
                ];
                General.callRestEngine('df#/crud/paramfilial', 'FilterData', filter).then(function(success){
                    if(success.dataset.paramfilial[0].IDUTILLCESTQ === 'S') {
                        local.reload();
                        local.readonly = false;
                    } 
                });
            }
            else local.readOnly = true;
        }  
        else local.readOnly = true;
    };
    
    /**
     * Altera o filtro do field de serie com os valores 
     * referentes a filial. - Somente para IDENTRSAIDOP = 'S' -
     * 
     * @param {object} fieldSerie field 'CDSERIE' da
     * widget documentos gerados.
     * @param {string} filial código da filial
    */
    this.setFilterSerieSaida = function(fieldSerie, filial) {
        var filter = [
            {
                "name":"CDFILIAL",
                "operator":"=",
                "value": filial
            }
        ];
        General.callRestEngine('df#/crud/filial', 'FilterData', filter).then(function(success){
            var rowFilial = success.dataset.filial;
            fieldSerie.dataSourceFilter[0].value =  rowFilial[0].CDEMPRESA;
            fieldSerie.dataSourceFilter[1].value =  rowFilial[0].CDINSCESTA;
            fieldSerie.dataSourceFilter[2].value =  rowFilial[0].CDINSCMUNI;
            fieldSerie.reload();
        });
    };
    
    /**
     * Altera o filed de 'CDSERIE' de acordo com 
     * IDENTRSAIDOP.
     * 
     * @param {object} fieldSerie field 'CDSERIE' da
     * widget documentos gerados.
     * @param {string} IDENTRSAIDOP 'E' para entrada
     * 'S' para saída
    */
    this.changeFieldSerie = function(field, IDENTRSAIDOP) {
        if(IDENTRSAIDOP === 'E') {
            field.valueField = "CDSERIEENTR";
            field.descriptionField = "CDSERIEENTR";
            field.outData = {"CDSERIEENTR": "CDSERIE"};
            field.dataSource.name = "df#/crud/serieentr";
            field.order = "CDSERIEENTR";
            field.dataSourceFilter = [];
            field.fields[0].isVisible = true;
            field.fields[1].isVisible = true;
            field.fields[2].isVisible = false;
            field.fields[3].isVisible = false;
            if(field.selectWidget)  {
                field.selectWidget.fields[0].isVisible = true;
                field.selectWidget.fields[1].isVisible = true;
                field.selectWidget.fields[2].isVisible = false;
                field.selectWidget.fields[3].isVisible = false;
                field.selectWidget.redraw();
            }
        }
        else if(IDENTRSAIDOP === 'S') {
            field.valueField = "CDSERIE";
            field.descriptionField = "CDSERIE";
            field.outData = {"CDSERIE": "CDSERIE"};
            field.dataSource.name = "df#/crud/serienf";
            field.order = "CDSERIE";
            field.fields[0].isVisible = false;
            field.fields[1].isVisible = false;
            field.fields[2].isVisible = true;
            field.fields[3].isVisible = true;
            if(field.selectWidget)  {
                field.selectWidget.outData = {"CDSERIE": "CDSERIE"};
                field.selectWidget.fields[0].isVisible = false;
                field.selectWidget.fields[1].isVisible = false;
                field.selectWidget.fields[2].isVisible = true;
                field.selectWidget.fields[3].isVisible = true;
                field.selectWidget.redraw();
            }
            field.dataSourceFilter = [
                {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "CDINSCESTA",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "CDINSCMUNI",
                    "operator": "=",
                    "value": ""
                }
            ];
        }
        field.reload();
    };
    
    //Função para consultar posição de estoque do produto escolhido para setar validação de quantidade maximo para o lançamento
    //OBS: verificar possibilidade de refatorar a busca da datadeprocessamento e busca-la de outro local para evitar requisição ao back.
    this.atualizaMaxQuantidade = function(widget) {
        var mensagem;
        var filial = widget.currentRow.CDFILIMOVI;
        var result = 0; 
        if(widget.currentRow.QTESTOQDIA === undefined){ // QTESTOQDIA será undefined caso unidade não controle almoxarifado ou local de estoque.

            widget.currentRow.IDQUANTID = 'N';
            if(!widget.currentRow.NRLOTEESTQ) widget.currentRow.NRLOTEESTQ = ' ';
                
            if(!widget.currentRow.NRSUBLOTE) widget.currentRow.NRSUBLOTE = ' ';
                
            if(!widget.currentRow.DTLANCMOVI) widget.currentRow.DTLANCMOVI = widget.getParent().currentRow.DTENTRSAID;
                
            if(!widget.currentRow.CDALMOXARIFE) widget.currentRow.CDALMOXARIFE = ' ';
                
            if(!widget.currentRow.CDLOCALESTOQ) widget.currentRow.CDLOCALESTOQ = ' ';

            
            ValidacoesEstoque_Service.verificaEstoqueProduto(widget.currentRow).then(function(success){
                if(success.dataset.lote_infCompl_semAlmox.length > 0) {
                    result = success.dataset.lote_infCompl_semAlmox[0].QTESTOQDIA; 
                }
                mensagem = "Posição Estoque: ".concat(result);
                widget.getField('QTITEMPROD').validations.max = {"value": result, "message": mensagem};
                General.callRestEngine("df#/crud/paramfilial", "FilterData", [{"name": "CDFILIAL", "operator": "=", "value": widget.currentRow.CDFILIAL}]).then((retorno) => {
                    if(widget.currentRow.IDCNTRESTOQ == 'N' || widget.getParent().currentRow.IDATUESTTPOP == 'N')
                        delete(widget.getField('QTITEMPROD').validations.max);  
                    else if(retorno.dataset.paramfilial[0].IDPERMESTNEG == 'S') 
                        delete(widget.getField('QTITEMPROD').validations.max);  
                    else if(widget.currentRow.CDSERVFILI)
                        delete(widget.getField('QTITEMPROD').validations.max);  
                });
            });    
            
        }else{
            mensagem = "Posição Estoque: ".concat(widget.currentRow.QTESTOQDIA);
            widget.getField('QTITEMPROD').validations.max = {"value": widget.currentRow.QTESTOQDIA, "message": mensagem};
            if(widget.currentRow.IDCNTRESTOQ == 'N' || widget.getParent().currentRow.IDATUESTTPOP == 'N')
                delete(widget.getField('QTITEMPROD').validations.max);
        }    
        
    };
    
    this.openPopupCopiarNF = function() {
        var wdgCopia = templateManager.container.getWidget('WidgetCopiarNF');
        var currentRowCabecalho = templateManager.container.getWidget('cabecalho').currentRow;
        if(currentRowCabecalho.IDSTATUS != 'D'){
            wdgCopia.currentRow = Util.clone(currentRowCabecalho);
            wdgCopia.getField("NMRAZSOCCLIE").dataSourceFilter[0].value = wdgCopia.currentRow.CDFILIEMIT;
            wdgCopia.currentRow.DTLANCAMENNF = moment().format('DD/MM/YYYY');
            wdgCopia.currentRow.LOTEORIG  = 'S';
            
            ScreenService.openPopup(wdgCopia);
            alteraVisibilidadeCampoInscricao(wdgCopia);
        }else{
            ScreenService.showMessage('Não é possível copiar notas em digitação');
        }
    };
    
    this.closePopupCopiaNF = function() {
        var wdgCopia = templateManager.container.getWidget('WidgetCopiarNF');
        ScreenService.closePopup(wdgCopia);
        wdgCopia.isVisible = false;
    };
    
    this.copiarNF = function(widget){
        if (widget.isValid()){
            let row = widget.currentRow;
            Dfs11000_LancamentoSaida_Service.copiarNF(row).then(function(success){
                this.closePopupCopiaNF();
                ScreenService.closePopup();
                ScreenService.closeSwipe();
                templateManager.container.getWidget('cabecalho').reload();
                ScreenService.showMessage(success.dataset.copiarNF.success);
                ScreenService.closePopup();
            }.bind(this)
            ).catch(function(error) {
                 ScreenService.closePopup();
                    var errosCopiar = templateManager.container.getWidget('errosCopiar');
                    if(error.data.dataset){
                        errosCopiar.dataSource.data = error.data.dataset.errosCopiarNF;
                        errosCopiar.isVisible = true;
                        ScreenService.openPopup(errosCopiar);
                    }
                    
                    ScreenService.showMessage(error.data.error);
            });
        }
    };
    
    this.popUpOperacaoOnChange = function(widget){
        alteraVisibilidadeCampoInscricao(widget);
        limpaCamposOutDataSelectsTpOperac(widget);
    };
    
    this.beginDataUpdate = function(widCabecalho) {
        if(!widCabecalho.dataSource.data.length) ScreenService.showMessage("É necessário filtrar dados para atualizar.");
        else {
            let widDataUpdate = getDataUpdateWidget();
            let tabDataUpdate = templateManager.container.getWidget('tabDataUpdate');
            let newDtSaida = tabDataUpdate.getField('NEWDTENTRSAID');
            
            this.openPopupDataUpdate(tabDataUpdate);
            if(newDtSaida.value()) newDtSaida.setValue();
            
            widDataUpdate.dataSourceFilter = widCabecalho.dataSourceFilter;
            widDataUpdate.reload();
        }
    };
    
    /*---------------------------------- Inicio - Importação de Solicitação de Compras ----------------------------------*/
    
    this.openImportacaoDeSolicitacaoDeCompra = function() {
        var widget = getCabecalhoWidget();
        var widgetPopup = getImportacaoWidget();
        
        widgetPopup.isVisible = true;
        ScreenService.openPopup(widgetPopup);
        widgetPopup.activate();
        
        MessageService.showMessageByCode('FUNCIONALIDADE_EM_DESENVOLVIMENTO');
        
        this.setValueFieldImportacaoDeSolicitacaoDeCompra(widget);
    };
    
    this.closeImportacao = function(){
        // Fecha a widget de importação
        
        var widgetOwner     = getCabecalhoWidget();
        var widgetPopup     = getImportacaoWidget();
        
        widgetPopup.reload();
        widgetPopup.getField("NMFILIRECE").setValue("");
        widgetPopup.getField("NMTIPOOPER").setValue("");
        widgetPopup.getField("DSSERIE").setValue("");
        widgetPopup.getField("UNDCONSULTA").setValue("");
        widgetPopup.getField("NRSOLICMP").setValue("");
        widgetPopup.getField("NMFILLANCA").setValue("");
        widgetPopup.getField("DTENTREGA").setValue("");
        widgetPopup.getField("DTENTRSAID").setValue("");
        
        widgetPopup.getField("ITENSSOL").readOnly = true;
        
        widgetPopup.getField("ITENSCOMPRA").setValue("");
        widgetPopup.getField("ITENSCOMPRA").readOnly = true;
        
        
        widgetPopup.isVisible = false;
        ScreenService.closePopup('importacaoSolicitacaoCompra');
            
        widgetOwner.reload();
        
    };
    
    this.closeItens = function(){
            var widget = templateManager.container.getWidget('itensSolicitacao');
            var widgetOwner = getImportacaoWidget(); 
            
            if(widget){
                widget.isVisible   = false;
                widget.deactivate();
                ScreenService.closePopup('importacaoSolicitacaoCompra');
                
                ScreenService.closePopup(widget.name);
                ScreenService.openPopup(widgetOwner);
                widgetOwner.isVisible = true;
                widgetOwner.activate();
                widgetOwner.getField("ITENSSOL").setValue("Não");
                widgetOwner.reload();
                
            }
        
    };
    
    this.testdestinoOrigem  = function() {
        const widget        = templateManager.container.getWidget('importacaoSolicitacaoCompra');
        const fieldUndDest  = widget.currentRow.NMFILIRECE;
        const fieldUndOrg   = widget.currentRow.NMFILIEMIT;
        
        if(fieldUndDest == fieldUndOrg) {
            
            widget.currentRow.NMFILIRECE = "";
            MessageService.showMessageByCode('CORRELACAO_ENTRE_UND_ENT_SAI');
            
        }
        widget.reload();
        
        if(fieldUndDest){
        
            widget.getField("UNDCONSULTA").readOnly = false;
            
        }
        
    };
    
    this.conditionOpenGrid  = function(args) {
        var widgetPopup     = getImportacaoWidget();
        let NRSOLICMP       = widgetPopup.currentRow.NRSOLICMP;
        let NMFILIRECE      = widgetPopup.currentRow.NMFILIRECE;
        let UNDCONSULTA     = widgetPopup.currentRow.UNDCONSULTA;
        let NMFILLANCA      = widgetPopup.currentRow.NMFILLANCA;
        let CDFILIRECE      = widgetPopup.currentRow.CDFILIRECE;
        

        if((NRSOLICMP != "") && 
        (NMFILIRECE != "") && 
        (NMFILLANCA != "") && 
        (UNDCONSULTA != "")){
            
            widgetPopup.getField("ITENSSOL").readOnly = false;
            widgetPopup.getField("ITENSCOMPRA").readOnly = false;
            
        }else{
            
            widgetPopup.getField("ITENSSOL").readOnly = true;
            widgetPopup.getField("ITENSCOMPRA").readOnly = true;
        }
        
        this.verificaDataSourceGridImportacaoItens();
        widgetPopup.getField("ITENSSOL").setValue("Não");
        
        
        
    };
    
    this.cleanUndLanc = function() {
        var widgetPopup     = getImportacaoWidget();
        let NRSOLICMP       = widgetPopup.currentRow.NRSOLICMP;
        
        if(NRSOLICMP == ""){ 
            
            widgetPopup.getField("NMFILLANCA").setValue("");
            
        }
    };
    
    this.openGridItens = function(){
        var widget      = getImportacaoWidget();
        let NRSOLICMP   = widget.currentRow.NRSOLICMP;
        let ITENSSOL    = widget.currentRow.ITENSSOL;
        
        if(ITENSSOL == "Sim"){
            
            if(NRSOLICMP != ""){
                
                    
                var widgetItens             = templateManager.container.getWidget('itensSolicitacao');
                    widgetItens.isVisible   = true;
                    ScreenService.openPopup(widgetItens);
                    widgetItens.activate();
                    widgetItens.reload();
            
            }
        }
        widget.currentRow.hasActive = 1;
    };
    
    this.setValueFieldImportacaoDeSolicitacaoDeCompra = function(){
        var widgetPopup = getImportacaoWidget();
        
        Df11000_Lancamento_Service.getDefaultNovaNotaSaida().then((success) => {
           
            //Insere valor no campo NMFILIEMIT
            widgetPopup.getField('NMFILIEMIT').reload();
            widgetPopup.getField("NMFILIEMIT").value(success[0].CDFILIEMIT);
            
            
            //Insere valor no campo nmempresa de acordo com o NMFILIEMIT
            
            widgetPopup.getField('NMEMPRESA').reload();
            widgetPopup.getField("NMEMPRESA").value(success[0].CDEMPRESA);
            
            
            //Insere valor no campo NMEMPRESARECE, que precisa ser igual ao nmempresa
            
            widgetPopup.getField('NMEMPRESARECE').reload();
            widgetPopup.getField("NMEMPRESARECE").value(success[0].CDEMPRESA);
            
        });
        widgetPopup.getField("ITENSSOL").value("Não");
        
        widgetPopup.reload();
        
        
    };
    
    this.setDefaultNovaNota = function (args) {
        var row = {CDFILIAL: args.e.preference.FILTER_ROW.CDFILIEMIT, IDENTRSAIDOP: 'S'};
        General.callRestEngine("df#/getDefaultLancamentoNota", "Row", row).then((success) => {
            
            Df11000_Lancamento_Service.setDefaultNovaNotaSaida(success.dataset.defaultNovaNota);
        });
    };
    
    this.setDefaultNovaNotaUndLanc = function (args) {
        
        let widget      = getImportacaoWidget();
        let NRSOLICMP   = widget.currentRow.NRSOLICMP;
        
        if(NRSOLICMP == ""){ 
            return "";
        }else{
            var row = {CDFILIAL: args.row.CDFILLANCA_SOL, IDENTRSAIDOP: 'S'};
            General.callRestEngine("df#/getDefaultLancamentoNota", "Row", row).then((success) => {
                
                Df11000_Lancamento_Service.setDefaultNovaNotaSaida(success.dataset.defaultNovaNota);
                widget.getField("NMFILLANCA").setValue(success.dataset.defaultNovaNota.NMFILIAL);
                
                this.conditionOpenGrid();
            });
        }
    };
    
    this.verificaDataSourceFieldsImportacao = function() {
        var widgetPopup     = getImportacaoWidget();
        
        widgetPopup.getField("NRSOLICMP").setValue("");
        widgetPopup.getField("NMFILLANCA").setValue("");
        
        let NRSOLICMP       = widgetPopup.getField("NRSOLICMP");
        let UNDCONSULTA     = widgetPopup.currentRow.UNDCONSULTA;
        let CDFILIEMIT      = widgetPopup.currentRow.CDFILIEMIT;
        let CDFILIRECE      = widgetPopup.currentRow.CDFILIRECE;
        let filter          = [];
        
        if(UNDCONSULTA == 'UL') {
            NRSOLICMP.dataSource.name = 'df#/solicitacaoUnidadeLancamento';
            
            filter = [
                { "name": "P_FILIDEST",   "operator": "=", "value": CDFILIRECE},
                { "name": "P_CDFILIAL",   "operator": "=", "value": CDFILIEMIT}, 
                { "name": "P_NRNUMESOLI", "operator": "=", "value": null}
            ];
            
        } else if(UNDCONSULTA == 'OL') {
            NRSOLICMP.dataSource.name = 'df#/solicitacaoOperadorLogistico';
            
            filter = [
                { "name": "P_FILIDEST",   "operator": "=", "value": CDFILIRECE},
                { "name": "P_NRNUMESOLI", "operator": "=", "value": null},
                { "name": "P_CDFILIAL",   "operator": "=", "value": CDFILIEMIT}, 
            ];
            
        } else if(UNDCONSULTA == 'CC') {
            NRSOLICMP.dataSource.name = 'df#/solicitacaoCCompra';
            
            filter = [
                { "name": "P_CDFILIAL",   "operator": "=", "value": CDFILIEMIT},
                { "name": "P_FILIDEST",   "operator": "=", "value": CDFILIRECE}, 
                { "name": "P_CDFILILANC", "operator": "=", "value": null},
                { "name": "P_NRNUMESOLI", "operator": "=", "value": null}
            ];
            
        } else if (UNDCONSULTA == 'CD'){
            NRSOLICMP.dataSource.name = 'df#/solicitacaoCDistribuicao';
            
            filter = [
                {"name": "P_FILIDEST",   "operator": "=", "value": CDFILIRECE},
                {"name": "P_CDFILIAL",   "operator": "=", "value": null},
                {"name": "P_NRNUMESOLI", "operator": "=", "value": null}
            ];
        }
        
        NRSOLICMP.dataSourceFilter = filter;
        
        if(UNDCONSULTA == ""){
            
            widgetPopup.getField("NRSOLICMP").readOnly      = true;
            widgetPopup.getField("ITENSCOMPRA").readOnly    = true;
            widgetPopup.getField("ITENSSOL").readOnly       = true;
            
        }else{
            
            widgetPopup.getField("NRSOLICMP").readOnly = false;
            
        }
        NRSOLICMP.reload();
    };
    
    this.verificaDataSourceGridImportacaoItens = function() {
        var widgetPopup         = getImportacaoWidget();
        var itensSolicitacao    = templateManager.container.getWidget("itensSolicitacao");
        
        let NRSOLICMP       = widgetPopup.currentRow.NRSOLICMP;
        let CDFILIRECE      = widgetPopup.currentRow.CDFILIRECE;
        let CDFILLANCA_SOL  = widgetPopup.currentRow.CDFILLANCA_SOL;
        let NRORG           = widgetPopup.currentRow.NRORG;
        let filter          = [];
        
        filter = [
            { "name": "P_CDFILSOLI",   "operator": "=", "value": CDFILIRECE},
            { "name": "P_CDFILLAN",    "operator": "=", "value": CDFILLANCA_SOL},
            { "name": "P_NRSOLICMP",   "operator": "=", "value": NRSOLICMP},
            { "name": "P_NRORG",       "operator": "=", "value": NRORG.toString()},
            { "name": "P_NRTIPOCUSTO", "operator": "=", "value": null}
        ];
           
        itensSolicitacao.dataSourceFilter = filter;
        
        templateManager.container.getWidget('importacaoSolicitacaoCompra').reload();
    };
    
    this.verificaDataSourceGridImportacaoCompras = function() {
        var widgetPopup     = getImportacaoWidget();
        var itensCompras    = widgetPopup.getField("ITENSCOMPRA");
        let UNDCONSULTA     = widgetPopup.currentRow.UNDCONSULTA;
        
        if(UNDCONSULTA == "OL")  {  
            
            let CDFILIEMIT  = widgetPopup.currentRow.CDFILIEMIT;
            let CDFILIRECE  = widgetPopup.currentRow.CDFILIRECE;
            let NRSOLICMP   = widgetPopup.currentRow.NRSOLICMP;
            let filter      = [];
            
            filter = [
                { "name": "P_CDFILIAL",    "operator": "=", "value": CDFILIEMIT},
                { "name": "P_CDFILIDESTI", "operator": "=", "value": CDFILIRECE},
                { "name": "P_NRSOLICMP",   "operator": "=", "value": NRSOLICMP},
                { "name": "P_OPERLOG",     "operator": "=", "value": CDFILIEMIT}
            ];
            
            
            itensCompras.dataSourceFilter = filter;
            widgetPopup.getField("ITENSCOMPRA").reload();
            
        }else{
            
            let CDFILIEMIT  = widgetPopup.currentRow.CDFILIEMIT;
            let CDFILIRECE  = widgetPopup.currentRow.CDFILIRECE;
            let NRSOLICMP   = widgetPopup.currentRow.NRSOLICMP;
            let filter      = [];
            
            filter = [
                
                { "name": "P_CDFILIAL",    "operator": "=", "value": CDFILIEMIT},
                { "name": "P_CDFILIDESTI", "operator": "=", "value": CDFILIRECE},
                { "name": "P_NRSOLICMP",   "operator": "=", "value": NRSOLICMP},
                { "name": "P_OPERLOG",     "operator": "=", "value": "T"}
            ];
               
            itensCompras.dataSourceFilter = filter;
            widgetPopup.getField("ITENSCOMPRA").reload();
        }
        
                
        this.tipoORGDEST();
    };
    
    this.verificaSerie = function() {
        var widget          = getImportacaoWidget();
        var widgetOwner     = getCabecalhoWidget();
        var filtro          = [];
        
        var CDINSCESTA      = widgetOwner.appliedFilter.FILTER_ROW.IEREM;
        var CDINSCMUNI      = widgetOwner.appliedFilter.FILTER_ROW.CDINSCMUNI;
        var CDEMPRESA       = widgetOwner.appliedFilter.FILTER_ROW.CDEMPRESA;
        
        filtro = [
                { "name": "CDINSCESTA",    "operator": "=", "value": CDINSCESTA},
                { "name": "CDEMPRESA",     "operator": "=", "value": CDEMPRESA},
                { "name": "CDINSCMUNI",    "operator": "=", "value": CDINSCMUNI}
        ];
        
        widget.getField("DSSERIE").dataSourceFilter = filtro;
        
    };
    
    //Faz com que o campo "destinatário no detalhamento, seja do tipo filial;
    this.tipoORGDEST     = function () {
        
        var widget       = getImportacaoWidget();
        var IDORIGDESTNF = widget.getField('IDORIGDESTNF');
            
            IDORIGDESTNF.setValue("L");
    };
    /*---------------------------------- Construção Nota Fiscal ----------------------------------*/
   
    
    
   this.saveImportacao = function(args){
        
        var Importacaoargs  = args;
        var widgetItens     = templateManager.container.getWidget('itensSolicitacao');
        var widget          = getImportacaoWidget();
        var widgetOwner     = getCabecalhoWidget();
        
        if((widget.currentRow.DTENTRSAID  == "") || (widget.currentRow.DTENTRSAID  == undefined)){
            widget.currentRow.DTENTRSAID  = widget.currentRow.DTENTREGA;
        }
            widgetItens.reload().then( () => {
                var itens;
                var rowCompras      = widget.getField("ITENSCOMPRA").dataSource.getCheckedRows();
                
                if(rowCompras.length != 0){
                    itens = rowCompras;
                }else{
                    itens = widgetItens.dataSource.data;
                }
                
                var rowOWN          = widget.currentRow;
                var CDFILIEMIT      = widget.currentRow.CDFILIEMIT;
                var CDTIPOOPER      = widget.currentRow.CDTIPOOPER;
                
                
                    
                //Salva: cabeçalho e itens
                      confereFilialLogada(Importacaoargs).then(function(success){
                                //save notafiscal
                                if (Importacaoargs.owner.widget.isValid()) {
                                    if (!Importacaoargs.row.NRINSJURCLIE && !Importacaoargs.row.CDFILIRECE && !Importacaoargs.row.DSINSJURNF)
                                        return ScreenService.showMessage("Destinatário da Nota Fiscal não informado.");
                        
                                    if (Importacaoargs.row.CDFILIRECE) {
                                        if (Importacaoargs.row.CDFILIRECE == Importacaoargs.row.CDFILIEMIT) {
                                            Importacaoargs.row.DSFILIRECE    = null;
                                            Importacaoargs.row.CDFILIRECE    = null;
                                            Importacaoargs.row.CDEMPRESARECE = null;
                                            return ScreenService.showMessage("Unidade de origem deve ser diferente da unidade de destino.");
                                        }
                                        else if (Importacaoargs.row.CDEMPRESARECE != Importacaoargs.row.CDEMPRESA) {
                                            Importacaoargs.row.DSFILIRECE    = null;
                                            Importacaoargs.row.CDFILIRECE    = null;
                                            Importacaoargs.row.CDEMPRESARECE = null;
                                            return ScreenService.showMessage("Unidade de destino deve possuir a mesma empresa da nota fiscal.");
                                        }
                                    }
                                }
                                
                                if (Importacaoargs.owner.widget.isValid()){
                                    ValidacoesEstoque_Service.validaDataLancamento(Importacaoargs.row.CDFILIEMIT, Importacaoargs.row.DTENTRSAID, "SAIDA", "DFS").then(function(){
                                        Importacaoargs.row.__is_new = true;
                                        //lancamentoCabecalhoArgs.row.__new_code_pk = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__new_code_pk+lancamentoCabecalhoArgs.row.CDFILIAL;
                                        Importacaoargs.row.__new_code_pk        = Importacaoargs.owner.widget.paramsNewCode.__new_code_pk;
                                        Importacaoargs.row.__using_unit         = Importacaoargs.owner.widget.paramsNewCode.__using_unit;
                                        Importacaoargs.row.__table_pk           = Importacaoargs.owner.widget.paramsNewCode.__table_pk;
                                        Importacaoargs.row.__new_code_length    = Importacaoargs.owner.widget.paramsNewCode.__new_code_length || 5;
                                        Importacaoargs.row.__columns_to_return  = Importacaoargs.owner.widget.paramsNewCode.__columns_to_return;
                                        Importacaoargs.row.VRPRODUTOS           = 0;
                                        Importacaoargs.row.VRNOTAFISC           = 0;
                                        Importacaoargs.row.IDENTRSAIDOP         = "S";
                                        Importacaoargs.row.IDBLOQUEADO          = "N";
                                        Importacaoargs.row.IDSISTEMA            = "DFS";
                                        Importacaoargs.row.IDDOCFINANC          = "S";
                                        Importacaoargs.row.IDSTATUS             = "D";
                                        Importacaoargs.row.DSMODDOCFISC         = "Nota Fiscal Eletrônica";
                                        Importacaoargs.row.CDMODDOCFISC         = "55";
                                        Importacaoargs.row.CDINSCESTA           = widgetOwner.appliedFilter.FILTER_ROW.IEREM;
                                        Importacaoargs.row.NRSEQCAPADOC         = "";
                                        Importacaoargs.row.DTCOMPFATUR          = moment().format("DD/MM/YYYY LTS");
                                        
                                        Df11000_Lancamento_Service.salvaCabecalho(Importacaoargs.row).then(function(callback){
                        
                                                if(Importacaoargs.row.__is_new){
                                                    Importacaoargs.row.CDFILIAL     = callback.dataset.columnsToReturn[0].CDFILIAL;
                                                    Importacaoargs.row.NRLANCTONF   = callback.dataset.columnsToReturn[0].NRLANCTONF;
                                                    Importacaoargs.row.NRORG        = callback.dataset.columnsToReturn[0].NRORG;
                                                    Importacaoargs.row.__is_new     = false;
                                                    reloadWidgetsFilhas(Importacaoargs.owner.widget);
                                                }
                                                
                                                Df11000_Lancamento_Service.setDataSourceCabecalho(Importacaoargs.row);
                                                Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                                                widget.isVisible = false;
                                                ScreenService.closePopup('importacaoSolicitacaoCompra');
                                                widgetOwner.reload();
                                                alteraVisibilidadeCampoInscricao(getCabecalhoWidget());
                                            
                                                //products save
                                                if (Importacaoargs.owner.widget.isValid()) {
                                                    
                                                            let j = 0;
                                                            itens.forEach( item => {
                                                                
                                                                if(!item.VRDESCITEM){
                                                                    item.VRDESCITEM   = '0';
                                                                }
                                                                
                                                                item.__is_new         = true;
                                                                item.CDFILIAL         = Importacaoargs.row.CDFILIAL;
                                                                item.NRLANCTONF       = Importacaoargs.row.NRLANCTONF;
                                                                item.NRORG            = Importacaoargs.row.NRORG;
                                                                
                                                                if(rowCompras.length != 0){
                                                                    item.CDPRODEMIS   = item.CDARVPROD;
                                                                    item.QTITEMPROD   = item.QTDECOMPRA;
                                                                    item.DSPRODEMIS   = item.NMPRODUTO;
                                                                }else{
                                                                    item.CDPRODEMIS   = item.CDARVPROD;
                                                                    item.QTITEMPROD   = item.QTSOLIPROD;
                                                                    item.DSPRODEMIS   = item.NMPRODUTO;
                                                                }
                                                                
                                                                item.CDALMOXARIFE     = " ";
                                                                item.CDLOCALESTOQ     = " ";
                                                                item.NRSUBLOTE        = " ";
                                                                item.NRLOTEESTQ       = " ";
                                                                item.VRUNITITEM       = '10';
                                                                item.CDFISOPEITEM     = "";
                                                                item.CDSITUTRIBPR     = "";
                                                                item.IDATUVRESTOQ     = 'S';
                                                                item.VRCONTITEM       = '0';
                                                                item.IDCONFORITEM     = 'S';
                                                                item.VRBRUTITEM       = '0';
                                                                j = j + 1;
                                                                item.NRSEQITPROD      = j;
                                                                
                                                                Df11000_Lancamento_Service.salvaItem(Importacaoargs.row, item).then(function(){
                                                                    Df11000_Lancamento_Service.setDataSourceItem(item).then(function(){
                                                                        Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                                                                            Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                                                                            widget.reload();
                                                                        });
                                                                    });
                                                                    
                                                                }, function(error) {
                                                                    if (Array.isArray(error)) {
                                                                        let stringCamposObrig = error.join(', ');
                                                                        let mensagem = "CAMPOS_MAIORES_ZERO";
                                                                        MessageService.showMessageByCode(mensagem, {"PARAMETRO": stringCamposObrig});
                                                                    } else if (typeof error === 'string')
                                                                        ScreenService.showMessage(error);
                                                                    if(error.data)
                                                                        ScreenService.showMessage(error.data.error);
                                                                });
                                                        });
                                                }
                                            }, requestError);
                                                
                                    }, requestError);
                                }
                        });   
                //fecha nota
            });
    
    };
    
    /*---------------------------------- Fim - Importação de Solicitação de Compras ----------------------------------*/
    
    this.openPopupDataUpdate = function(widTabDataUpdate) {
        widTabDataUpdate.isVisible = true;
        ScreenService.openPopup(widTabDataUpdate);
        widTabDataUpdate.activate();
    };
    
    this.saveDataUpdate = function(tabDataUpdate, widDataUpdate) {
        if(tabDataUpdate.isValid()) {
            if(!widDataUpdate.hasCheckedRows()) ScreenService.showMessage("Selecione uma nota para atualizar.");
            else {
                let self = this;
                ScreenService.confirmMessage('Confirma a atualização e o fechamento da(s) nota(s) ?', 'question', function (success) {
                    let rowsUpdate = widDataUpdate.getCheckedRows();
                    let NEWDTENTRSAID = tabDataUpdate.getField('NEWDTENTRSAID').value();
                    Dfs11000_LancamentoSaida_Service.saveDataUpdate(rowsUpdate, NEWDTENTRSAID).then (function (success) {
                        widDataUpdate.reload().then(() => {
                            if(widDataUpdate.dataSource.data.length) widDataUpdate.unSelectAll();
                            else self.closePopupDataUpdate(tabDataUpdate);
                        });
                        ScreenService.showMessage(success.messages[0].message);
                    }, requestError);
                });
            }
        }
    };
    
    this.closePopupDataUpdate = function(widTabDataUpdate) {
        let widDataUpdate = getDataUpdateWidget();
        
        widDataUpdate.unSelectAll();
        widDataUpdate.dataSource.data = [];
        
        widTabDataUpdate.isVisible = false;
        ScreenService.closePopup(widTabDataUpdate);
        widTabDataUpdate.getParent().activate();
        widTabDataUpdate.getParent().reload();
    };
    
    let getDataUpdateWidget = function() {
        return templateManager.container.getWidget('wdg_DataUpdate');
    };
    
    this.getFieldSerieFromFilterPopup = function(fieldSerie) {
        fieldSerie.dataSourceFilter.forEach(data => {
            if(data.name == "CDEMPRESA") data.value = this.getFieldFromFilterPopup('CDEMPRESA');
            if(data.name == "CDINSCESTA") data.value = this.getFieldFromFilterPopup('IEREM');
            if(data.name == "CDINSCMUNI") data.value = this.getFieldFromFilterPopup('CDINSCMUNI');
        });
    };
    
    this.nmPaisNotaOnChange = function(widget) {
        widget.getField('SGESTADONOTA').readOnly = widget.currentRow.CDPAISNOTA ? false : true;
        widget.getField('NMMUNICIPIONOTA').readOnly = true;
        widget.currentRow.CDMUNICIPIO = null;
        widget.currentRow.CDMUNICIPIONOTA = null;
        widget.currentRow.NMMUNICIPIONOTA = null;
        widget.currentRow.SGESTADO = null;
        widget.currentRow.SGESTADONOTA = null;
        widget.currentRow.NMESTADONOTA = null;
        if (widget.currentRow.CDPAISNOTA) {
    		widget.getField('SGESTADONOTA').dataSourceFilter.forEach(data => {
    		    if(data.name == "CDPAIS") data.value = widget.currentRow.CDPAISNOTA;
    		});
    		widget.getField('NMMUNICIPIONOTA').dataSourceFilter.forEach(data => {
    		    if(data.name == "CDPAIS") data.value = widget.currentRow.CDPAISNOTA;
    		});
        }
    };
    
    this.sgEstadoNotaOnChange = function(widget) {
        widget.getField('NMMUNICIPIONOTA').readOnly = widget.currentRow.SGESTADONOTA ? false : true;
        widget.currentRow.CDMUNICIPIO = null;
        widget.currentRow.CDMUNICIPIONOTA = null;
        widget.currentRow.NMMUNICIPIONOTA = null;
		widget.currentRow.SGESTADO = widget.currentRow.SGESTADONOTA;
		if (widget.currentRow.SGESTADONOTA) {
    		widget.getField('NMMUNICIPIONOTA').dataSourceFilter.forEach(data => {
    		    if(data.name == "SGESTADO") data.value = widget.currentRow.SGESTADONOTA;
    		});
		}
    };
    
    this.nmMunicipioNotaOnChange = function(widget) {
        widget.currentRow.CDMUNICIPIO = widget.currentRow.CDMUNICIPIONOTA;
   };
    
    this.controlVisibilityLocalPrestServ = function(widget) {
        let fieldSGESTADONOTA = widget.getField('SGESTADONOTA');
        let fieldNMMUNICIPIONOTA = widget.getField('NMMUNICIPIONOTA');
        let fieldNMPAISNOTA = widget.getField('NMPAISNOTA');
        let fieldIDNATUOPER = widget.getField('IDNATUOPER');
        let utilizaNFSe = widget.currentRow.IDUTILNFSE === 'S' ? true : false;
        
        if(widget.editing) { //True = Add e edit nota.
            if(utilizaNFSe) {
                if(widget.currentRow.__is_new) {
                    widget.currentRow.IDNATUOPER = null;
                    widget.currentRow.CDPAISNOTA = null;
                    widget.currentRow.NMPAISNOTA = null;
                    widget.currentRow.CDMUNICIPIONOTA = null;
                    widget.currentRow.NMMUNICIPIONOTA = null;
                    widget.currentRow.SGESTADONOTA = null;
                    widget.currentRow.NMESTADONOTA = null;
                } else {
                    if (widget.currentRow.CDPAISNOTA) {
                        widget.getField('SGESTADONOTA').dataSourceFilter.forEach(data => {
                		    if(data.name == "CDPAIS") data.value = widget.currentRow.CDPAISNOTA;
                		});
                		widget.getField('NMMUNICIPIONOTA').dataSourceFilter.forEach(data => {
                		    if(data.name == "CDPAIS") data.value = widget.currentRow.CDPAISNOTA;
                		});
                    }
                    if (widget.currentRow.SGESTADONOTA) {
                        widget.getField('NMMUNICIPIONOTA').dataSourceFilter.forEach(data => {
                		    if(data.name == "SGESTADO") data.value = widget.currentRow.SGESTADONOTA;
                		});
                    }
                }
                widget.fieldGroups.forEach(group => {
                    if(group.name === 'prestacaoServico') {
                        group.isVisible = true;
                        group.opened = true;
                    }
                });
                widget.currentRow.SGESTADO = widget.currentRow.SGESTADONOTA;
                widget.currentRow.CDMUNICIPIO = widget.currentRow.CDMUNICIPIONOTA;
                
                fieldIDNATUOPER.isVisible = true;
                fieldIDNATUOPER.readOnly = false;
                fieldIDNATUOPER.validations.required = true;
                
                fieldNMPAISNOTA.isVisible = true;
                fieldNMPAISNOTA.readOnly = false;
                fieldNMPAISNOTA.validations.required = true;
                
                fieldSGESTADONOTA.isVisible = true;
                fieldSGESTADONOTA.readOnly = widget.currentRow.CDPAISNOTA ? false : true;
                fieldSGESTADONOTA.validations.required = true;
                
                fieldNMMUNICIPIONOTA.isVisible = true;
                fieldNMMUNICIPIONOTA.readOnly = widget.currentRow.SGESTADONOTA ? false : true;
                fieldNMMUNICIPIONOTA.validations.required = true;
            } else {
                widget.fieldGroups.forEach(group => {
                    if(group.name === 'prestacaoServico') {
                        group.isVisible = false;
                        group.opened = false;
                    }
                });
                fieldIDNATUOPER.isVisible = false;
                fieldIDNATUOPER.readOnly = true;
                fieldIDNATUOPER.validations.required = false;
                
                fieldNMPAISNOTA.isVisible = false;
                fieldNMPAISNOTA.readOnly = true;
                fieldNMPAISNOTA.validations.required = false;
                
                fieldSGESTADONOTA.isVisible = false;
                fieldSGESTADONOTA.readOnly = true;
                fieldSGESTADONOTA.validations.required = false;
                
                fieldNMMUNICIPIONOTA.isVisible = false;
                fieldNMMUNICIPIONOTA.readOnly = true;
                fieldNMMUNICIPIONOTA.validations.required = false;
            }
        } else { //False = Visualizar nota.
            if(utilizaNFSe) {
                widget.fieldGroups.forEach(group => {
                    if(group.name === 'prestacaoServico') {
                        group.isVisible = true;
                    }
                });
                fieldIDNATUOPER.isVisible = true;
                fieldNMPAISNOTA.isVisible = true;
                fieldSGESTADONOTA.isVisible = true;
                fieldNMMUNICIPIONOTA.isVisible = true;
            } else {
                widget.fieldGroups.forEach(group => {
                    if(group.name === 'prestacaoServico') {
                        group.isVisible = false;
                    }
                });
                fieldIDNATUOPER.isVisible = false;
                fieldNMPAISNOTA.isVisible = false;
                fieldSGESTADONOTA.isVisible = false;
                fieldNMMUNICIPIONOTA.isVisible = false;
            }
        }
    };
   
    this.reloadNumeroNotaFiscal = function() {
        let currentRow = getCabecalhoWidget().currentRow;
        let data = getCabecalhoWidget().dataSource.data;
        data.forEach(function(row) {
            if(row.NRLANCTONF == currentRow.NRLANCTONF) {
                if(getCabecalhoWidget().inViewMode()) {
                    currentRow.NRNOTAFISC = row.NRNOTAFISC;
                    getCabecalhoWidget().reload();
                }
            }
        });
    };
    
    var validaNumeroNF = function(cabecalhoWidget) {
        var NRNOTAFISC = cabecalhoWidget.getField("NRNOTAFISC");
        var currentRow = cabecalhoWidget.currentRow;
        
        if(currentRow.IDPERNUMENF == "S")
            NRNOTAFISC.readOnly = false;
        else 
            NRNOTAFISC.readOnly = true;    
    };
    
    var applyZeroFillNumeroNota = function(cabecalhoWidget) {
        var filter =  [{"name": "CDFILIAL", "operator": "=", "value": cabecalhoWidget.currentRow.CDFILIEMIT}],
            nrNotaFiscField = cabecalhoWidget.getField('NRNOTAFISC'),
            nrTamNumNfUt,
            quantCaracteres;
        
        General.callRestEngine("df#/crud/paramfilial", "FilterData", filter).then((success) => {
            if(success.dataset.paramfilial[0]) 
                nrTamNumNfUt = success.dataset.paramfilial[0].NRTAMNUMNFUT;
            
            quantCaracteres = nrTamNumNfUt ? nrTamNumNfUt : 9;
            nrNotaFiscField.mask.params.maxlength = quantCaracteres;
            nrNotaFiscField.validations.maxLength.length = nrTamNumNfUt ? nrTamNumNfUt : 20;
            nrNotaFiscField.reload();
        });
    };
    
    var alteraVisibilidadeCampoNaturezaOper = function(cabecalhoWidget, tipoOperacaoOnChange) {
        var IDNFAJUSTE   = cabecalhoWidget.currentRow.IDNFAJUSTE,
            CDTIPOOPER   = cabecalhoWidget.currentRow.CDTIPOOPER,
            DSCDFISOPENF = cabecalhoWidget.getField("DSCDFISOPENF"),
            IDNATUOPER   = cabecalhoWidget.getField("IDNATUOPER"),
            utilizaNFSe  = cabecalhoWidget.currentRow.IDUTILNFSE === 'S' ? true : false; 
          
        if(!utilizaNFSe) {    
            if(IDNFAJUSTE == "S" || CDTIPOOPER == "03") {
                DSCDFISOPENF.readOnly = false;
                DSCDFISOPENF.isVisible = true;
                DSCDFISOPENF.validations.required = true;
                if(cabecalhoWidget.currentRow.__is_new) {
                    DSCDFISOPENF.clearValue();
                }
            } else {
            	if (tipoOperacaoOnChange) DSCDFISOPENF.clearValue();
                DSCDFISOPENF.readOnly = true;
                DSCDFISOPENF.isVisible = true;
                delete DSCDFISOPENF.validations.required;
            }
        } else {
            DSCDFISOPENF.isVisible = false;
            delete DSCDFISOPENF.validations.required;
        }
    };
    
    var changeDataSourceNotaOrigem = function(cabecalhoWidget) {
        var notaOrigemField = cabecalhoWidget.getField('DSNOTAORIGEM'),
            tipooperac  = cabecalhoWidget.currentRow.CDTIPOOPER,
            idNfAjuste  = cabecalhoWidget.currentRow.IDNFAJUSTE,
            filter      = [ {name: "P_FILIAL", operator: "=", value: cabecalhoWidget.currentRow.CDFILIEMIT},
                            {name: "P_CDFILIORIGEM", operator: "=", value: "T"},
                            {name: "P_IDTPIJURNF", operator: "=", value: cabecalhoWidget.currentRow.IDTPIJURNF},
                            {name: "P_NRINSJURNF", operator: "=", value:  cabecalhoWidget.currentRow.NRINSJURNF},
                            {name: "P_NOTAFISC", operator: "=", value: "T"},
                            {name: "P_CDTIPOOPER", operator: "=", value: ""},
                            {name: "P_SERIE", operator: "=", value: "T"}],
            dataSourceName = (idNfAjuste == 'S' || tipooperac == '03') ? 'df#/crud/notafiscal_origem_saida' : 'df#/crud/notafiscal_origem_entrada';

        if(dataSourceName) {
            General.callRestEngine(dataSourceName, 'FilterData', filter).then(function(sucess) {
                notaOrigemField.dataSource.name = dataSourceName;
                notaOrigemField.dataSource.data = sucess.dataset.dataSourceName;
                notaOrigemField.reload();
            });
        }
    };
    
    this.validacoesFieldGroupIntermediador = function(cabecalhoWidget) {
        var intermedGroup = cabecalhoWidget.fieldGroups.filter(group => group.name === 'intermediador')[0];
        var intermediador = cabecalhoWidget.currentRow.IDINTERMED;
        var cnpjIntermed = cabecalhoWidget.getField('NRCNPJINTERMED');
        var nmCadIntermed = cabecalhoWidget.getField('NMCADINTERMED');

        if(intermediador == '1') {
           cnpjIntermed.validations  = { "required":  true};
           nmCadIntermed.validations = { "required":  true,
                                         "maxLength": {"length": 60},
                                         "minLength": {"length": 2}};

            nmCadIntermed.readOnly = false;
            cnpjIntermed.readOnly = false;

            intermedGroup.opened = true;
        }
        else {
            nmCadIntermed.readOnly = true;
            cnpjIntermed.readOnly = true;

            nmCadIntermed.clearValue();
            cnpjIntermed.clearValue();

            intermedGroup.opened = false;

            delete nmCadIntermed.validations;
            delete cnpjIntermed.validations;
        }
        nmCadIntermed.reload();
        cnpjIntermed.reload();
    };
    
    var defaultValueIndicadorPresenca = function(cabecalhoWidget) {
        if(cabecalhoWidget.currentRow.IDNFAJUSTE == 'S' || cabecalhoWidget.currentRow.CDTIPOOPER == '03')
            cabecalhoWidget.getField('IDPRESENCIAL').setValue('0');
        else
            cabecalhoWidget.getField('IDPRESENCIAL').setValue('9');
        
        cabecalhoWidget.getField('IDPRESENCIAL').reload();
    };
    
    this.actSalvaImpostosItemWidgetOnSaveInlineEdit = function(impostosItemArgs) {
        var impostosItemWidget =  templateManager.container.getWidget("impostosItem");
        const data = impostosItemWidget.dataSource.data;
        var statusNota = getCabecalhoWidget().currentRow.IDSTATUS;
        const camposAlterados = data.filter(row =>  !!('changed_CDIMPOSTO' in row)  ||    
                                                    !!('changed_VRBASECALCIT' in row)  ||
                                                    !!('changed_VRPERREDBCIT' in row)  ||
                                                    !!('changed_VRPERMAJBCIT' in row)  ||
                                                    !!('changed_VRADICALIQFECP' in row)  ||
                                                    !!('changed_CDFISCALIT' in row)  ||
                                                    !!('changed_CDSITUTRIBITNFE' in row)  ||
                                                    !!('changed_IDMODBCITNFE' in row)  ||
                                                    !!('changed_IDMODBCSTITNFE' in row)  ||
                                                    !!('changed_CDCEST' in row)  ||
                                                    !!('changed_CDBENEFFISCAL' in row)  ||
                                                    !!('changed_VRIMPOSTODESON' in row)  ||
                                                    !!('changed_IDMOTDESONERAIT' in row)  ||
                                                    !!('changed_CDENQLEGALIPI' in row) ||
                                                    !!('changed_VRIMPOSTOIT' in row) ||
                                                    !!('changed_VRALIQITEM' in row) ||
                                                    !!('changed_SGIMPOSTO' in row) ||
                                                    !!('changed_IDCONSDESONVRNF' in row));
         
        if(validaCamposImpostoItemEditInline()) {       
            const salvaImpostosItem = () =>
                Df11000_Lancamento_Service.salvaImpostosItem(camposAlterados)
                .then(() => {
                    removeEdicaoLinhasWidget(camposAlterados);
                    impostosItemWidget.list();
                })
                .catch(requestError);
            
            if (statusNota !== 'D') {
                alteraStatusNotafiscal(impostosItemWidget);
                impostosItemWidget.getParent().reload();
            }
            
            salvaImpostosItem();
        }


    };
    
    var removeEdicaoLinhasWidget = function(registrosAlterados) {
        registrosAlterados.forEach(registro => {
            Object.keys(registro).filter(key => !key.indexOf('changed') ? delete registro[key] : !key.indexOf('changed'));
        });
    };
    
    this.actSalvarImposto = function() {
        var impostosItemWidget = getImpostosItensWidget();
        var currentRow = impostosItemWidget.currentRow;
        var statusNota = getCabecalhoWidget().currentRow.IDSTATUS;
        var impostos = [{
            "CDBENEFFISCAL": currentRow.CDBENEFFISCAL,
            "CDCEST": currentRow.CDCEST,
            "CDENQLEGALIPI": currentRow.CDENQLEGALIPI,
            "CDFILIAL":  getCabecalhoWidget().currentRow.CDFILIAL,
            "CDFISCALIT": currentRow.CDFISCALIT ? currentRow.CDFISCALIT : 1,
            "CDFISCOPERIT": "",
            "CDIMPOSTO": currentRow.CDIMPOSTO,
            "CDREGRAIT": "",
            "CDSITUTRIBIT": getItensWidget().currentRow.CDSITUTRIBPR,
            "CDSITUTRIBITNFE": currentRow.CDSITUTRIBITNFE,
            "IDCONSDESONVRNF":  currentRow.IDCONSDESONVRNF?  currentRow.IDCONSDESONVRNF : "N",
            "IDMODBCITNFE":  currentRow.IDMODBCITNFE,
            "IDMODBCSTITNFE": currentRow.IDMODBCSTITNFE,
            "IDMOTDESONERAIT": currentRow.IDMOTDESONERAIT ? currentRow.IDMOTDESONERAIT : "9",
            "NRITPROIMPOS": '1',
            "NRLANCTONF": getCabecalhoWidget().currentRow.NRLANCTONF,
            "NRSEQITPROD": getItensWidget().currentRow.NRSEQITPROD,
            "VRADICALIQFECP": currentRow.VRADICALIQFECP ? currentRow.VRADICALIQFECP : 0,
            "VRADICFECP": currentRow.VRADICFECP ? currentRow.VRADICFECP : 0,
            "VRALIQITEM": currentRow.VRALIQITEM ? currentRow.VRALIQITEM : 0,
            "VRBASECALCIT": currentRow.VRBASECALCIT ? currentRow.VRBASECALCIT : 0,
            "VRCONTITIMP": currentRow.VRCONTITIMP ? currentRow.VRCONTITIMP : 0,
            "VRIMPOSTODESON": currentRow.VRIMPOSTODESON ? currentRow.VRIMPOSTODESON : 0,
            "VRIMPOSTOIT": currentRow.VRIMPOSTOIT ? currentRow.VRIMPOSTOIT : 0,
            "VRPARDEDIT": currentRow.VRPARDEDIT ? currentRow.VRPARDEDIT : 0,
            "VRPERMAJBCIT": currentRow.VRPERMAJBCIT ? currentRow.VRPERMAJBCIT : 0,
            "VRPERREDBCIT": currentRow.VRPERREDBCIT ? currentRow.VRPERREDBCIT : 0
        }];
        
        if(validaPreenchimentoObrigatorioImpostos() && !(validaImpostoItemCadastrado(impostos[0]))) {
            const salvaImpostosItem = () =>
            General.callRestEngine("df#/salvarImpostoItem", "Row", impostos)
            .then(() => {
                this.reloadDataSourceImpostoItem();
                ScreenService.closeSwipe();
            })
            .catch(requestError);
            if (statusNota !== 'D') {
                alteraStatusNotafiscal(impostosItemWidget);
                impostosItemWidget.getParent().reload();
            }
            salvaImpostosItem();
        }
    };
    
    this.verificaDataSourceProduto = function(field) {
        var cdTipoOper  = getCabecalhoWidget().currentRow.CDTIPOOPER;
        var filter = [];
        
        if(cdTipoOper == '03') {
            field.dataSource.name = 'df#/itemproduto_notafiscal_origem';
            filter = [
                { "name": "P_NRLANCTONF", "operator": "=", "value": getCabecalhoWidget().currentRow.NRLANCTONF},
                { "name": "P_CDFILIAL",   "operator": "=", "value": getCabecalhoWidget().currentRow.CDFILIAL}, 
                { "name": "P_NRORG",      "operator": "=", "value": getCabecalhoWidget().currentRow.NRORG}
            ];
        } else {
            field.dataSource.name = 'df#/produtoLancamento';
            filter = [
                {"name": "CDFILIAL", "operator": "=", "value": getCabecalhoWidget().currentRow.CDFILIEMIT},
                {"name": "CDNVPRODUTO", "operator": "=", "value": this.nivelCompletoProduto()}
            ];
        }
        
        field.dataSourceFilter = filter;
        field.reload();
    };
    
    
    var alteraEdicaoCamposImpostos = function(impostosItemWidget) {
        var currentRow = getCabecalhoWidget().currentRow;
        var permiteEditarImposto = currentRow.CDTIPOOPER == '03' || currentRow.IDNFAJUSTE == 'S';
        
        impostosItemWidget.fields.forEach((field) => {
            if(permiteEditarImposto) {
                if(field.name != 'CDIMPOSTO' && field.name != 'SGIMPOSTO') {
                    if(field.name == 'IDMODBCITNFE' || field.name == 'IDCONSDESONVRNF' || field.name == 'IDMOTDESONERAIT' || field.name == 'IDMODBCSTITNFE' || field.name == 'CDFISCALIT')
                        field.inlineEditable = "select-native";
                    else if(field.name == 'IDMODBCITNFE')
                        field.inlineEditable = permiteEditarImposto;
                    else 
                        field.inlineEditable = "number";
                }
            } else { 
                if(field.inlineEditable)
                    delete field.inlineEditable;
            }
        });
        
    };
    
    var visibilidadeActionsWidgetImposto = function(impostosItemWidget) {
        var currentRow = getCabecalhoWidget().currentRow;
        var isVisible =  currentRow.CDTIPOOPER == '03' || currentRow.IDNFAJUSTE == 'S';
        impostosItemWidget.getAction('adicionarImposto').isVisible = isVisible;
        impostosItemWidget.getAction('excluirImposto').isVisible = isVisible;
    };
    
    var validaPreenchimentoObrigatorioImpostos = function() {
        var impostosItemWidget =  templateManager.container.getWidget("impostosItem");
        var fields = impostosItemWidget.fields;
        var camposInvalidos = [];
        
        fields.forEach(field => {
            if(field.name == 'VRALIQITEM' || field.name == 'SGIMPOSTO' || field.name == 'VRIMPOSTOIT' || field.name == 'CDFISCALIT'|| field.name == 'CDSITUTRIBITNFE') {
                if(!field.value())
                    camposInvalidos.push(field.label);
            }
        });
        
        if(camposInvalidos.length > 0) {
            MessageService.showMessageByCode('CAMPOS_OBRIGATORIOS', {"PARAMETRO": camposInvalidos});
            return false;
        } 
            
        return true; 
        
    
    };
    
    var validaObrigatoriedadeFields = function() {
        var currentRow = getCabecalhoWidget().currentRow;
        var cstnfe = getImpostosItensWidget().getField('CDSITUTRIBITNFE');
        var cdfiscalit = getImpostosItensWidget().getField('CDFISCALIT');

        if(currentRow.CDTIPOOPER == '03' || currentRow.IDNFAJUSTE == 'S') {
            setCampoObrigatorio(cstnfe);
            setCampoObrigatorio(cdfiscalit);
        } else {
            delete cstnfe.validations;
            cstnfe.readOnly = true;
            delete cdfiscalit.validations;
            cdfiscalit.readOnly = true;
        }
    };
    
    this.validacoesImpostosWidgetOnEnter = function(itemImpostosWidget) {
        validaObrigatoriedadeFields();
        alteraEdicaoCamposImpostos(itemImpostosWidget);
        visibilidadeActionsWidgetImposto(itemImpostosWidget);
        
        this.reloadDataSourceImpostoItem();
    };
    
    this.deleteItemProImpos = function(impostosItemArgs) {
        var impostosItemWidget = impostosItemArgs.owner.widget;
        var excluir = impostosItemWidget.currentRow;
        var statusNota = getCabecalhoWidget().currentRow.IDSTATUS;
         
        MessageService.confirmMessageByCode("REGISTRO_EXCLUIR").then(sucess => {
            General.callRestEngine("df#/deleteImpostoItem", "Row", excluir).then(function() {
                MessageService.showMessageByCode("REGISTRO_EXCLUIDO").then(function() {
                    ScreenService.closeSwipe();
                    if (statusNota !== 'D') {
                        alteraStatusNotafiscal(impostosItemWidget);
                        this.reloadDataSourceImpostoItem();
                        impostosItemWidget.getParent().reload();
                    }
                }).catch((error) => {
                    ScreenService.showMessage(error.data.error);
                });
            });

        });
    };
    
    this.validacoesItensOnEnter = function() {
        var currentRow = getCabecalhoWidget().currentRow;
        var cst = getItensWidget().getField('CDSITUTRIBPR');
        var cfop = getItensWidget().getField('CDFISOPEITEM');

        if(currentRow.CDTIPOOPER == '03' || currentRow.IDNFAJUSTE == 'S') {
            setCampoObrigatorio(cst);
            setCampoObrigatorio(cfop);
        } else {
            delete cst.validations;
            cst.readOnly = true;
            delete cfop.validations;
            cfop.readOnly = true;
        }

    };
    
    this.validaCNPJ = function (field) {
        if (!field.value()) {
            return;
        }
        if (!General.validateCNPJ(field.value())) {
            MessageService.showMessageByCode('CNPJ_INVALIDO');
            field.setValue("");
        }
    };
    
    var validaImpostoItemCadastrado = function(imposto) {
        var data = getImpostosItensWidget().dataSource.data.filter(data => data.CDIMPOSTO === imposto.CDIMPOSTO);
        if(data.length > 1)
            MessageService.showMessageByCode('IMPOSTO_JA_CADASTRADO');
            
        return data.length > 1;
    };
    
    var validaCamposImpostoItemEditInline = function() {
        var impostosItemWidget =  templateManager.container.getWidget("impostosItem");
        var rowsAlteradas = impostosItemWidget.dataSource.data.filter(row => row.changed);
        var camposInvalidos = [];
        var isAliquotaEmpty = false;
        var isValorEmpty = false;
        var isCstNfeEmpty = false;
        
        rowsAlteradas.forEach(row => {
            if(!row.VRALIQITEM) 
                isAliquotaEmpty = true;
            if(!row.VRIMPOSTOIT)  
                isValorEmpty = true;
            if(!row.CDSITUTRIBITNFE) 
                isCstNfeEmpty = true;
        });
        
        if(isAliquotaEmpty) 
            camposInvalidos.push('Alíquota');
        if(isValorEmpty)  
            camposInvalidos.push('Valor');
        if(isCstNfeEmpty) 
            camposInvalidos.push('CST NFe');
    
        if(camposInvalidos.length > 0) {
            MessageService.showMessageByCode('CAMPOS_OBRIGATORIOS', {"PARAMETRO": camposInvalidos});
            return false;
        } 
            
        return true; 
        
    };

    this.reloadDataSourceImpostoItem = function() {
        var filter = [{"name": "NRSEQITPROD", "operator": "=", "value": getItensWidget().currentRow.NRSEQITPROD},
                      {"name": "NRLANCTONF", "operator": "=", "value": getCabecalhoWidget().currentRow.NRLANCTONF},
                      {"name": "CDFILIAL", "operator": "=", "value": getCabecalhoWidget().currentRow.CDFILIAL}];
                      
        General.callRestEngine("df#/crud/itemproimpos_notafiscal_itemproduto_imposto", "FilterData", filter).then((success) => {
            getImpostosItensWidget().dataSource.data = success.dataset.itemproimpos_notafiscal_itemproduto_imposto;
            
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfs11000_LancamentoSaida_Controller", dfs11000_LancamentoSaida_Controller);
});