function autorizacaoParaObterXml() {
    const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
    const z = new ZeedhiAPIConstructor(browser, protractor);
    const Helper = require('teknisa-helper');
    const geralPage = new Helper.geral();
    const protractorHelper = require('protractor-helper');
    const j = require('../../../json/leitorJson.po');
    const self = this;
    this.abrir = () => {
        z.component.menu.open();
        protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
        z.component.menu.clickByPath(['Parametrização', 'Documentos Fiscais', 'Autorização Para Obter XML']);
        geralPage.esperarLoading();
    };



    this.adicionarPessoaFisica = (nrinsjurautoxml, dsobsautoxml) => {
        geralPage.clickAdicionar();
        geralPage.fillField('NRINSJURAUTOXML', nrinsjurautoxml);
        geralPage.fillField('DSOBSAUTOXML', dsobsautoxml);
        geralPage.clickSalvar();
    };

    this.adicionarPessoaJuridica = (nrinsjurautoxml, dsobsautoxml) => {
        element(by.className('close zh-icon zh-icon-down')).click();
        geralPage.clickAdicionar();
        geralPage.fillField('NRINSJURAUTOXML', nrinsjurautoxml);
        geralPage.fillField('DSOBSAUTOXML', dsobsautoxml);
        geralPage.clickSalvar();
    };

    this.editarPessoaJuridica = (dsobsautoxml) => {
        geralPage.clickGrid('DSOBSAUTOXML', j.getValor('dsobsautoxml02'), '495202327411421901674', false);
        geralPage.clickEditar();
        geralPage.fillField('DSOBSAUTOXML', dsobsautoxml);
        geralPage.clickSalvar();
    };

    this.excluirPessoaFisica = (dsobsautoxml) => {
        geralPage.clickGrid('DSOBSAUTOXML', dsobsautoxml, '495202327411421901674', false);
        geralPage.clickExcluir();
        geralPage.clickSim();
    };

    this.adicionarPessoaFisicaPorIe = (nrinsjurautoxml, dsobsautoxml) => {
        geralPage.trocarAba('Inscrição Estadual');
        geralPage.searchAndClickGridField('NMEMPRESA', j.getValor('unidade02'), 'NMEMPRESA');
        geralPage.searchAndClickGridField('CDINSCESTA', j.getValor('cdinscesta01'), 'CDINSCESTA');
        geralPage.clickAdicionar();
        geralPage.fillField('NRINSJURAUTOXML', nrinsjurautoxml);
        geralPage.fillField('DSOBSAUTOXML', dsobsautoxml);
        geralPage.clickSalvar();
    };

    this.adicionarPessoaJuridicaPorIe = (nrinsjurautoxml, dsobsautoxml) => {
        // geralPage.trocarAba('Inscrição Estadual');
        // geralPage.searchAndClickGridField('NMEMPRESA', j.getValor('unidade02'), 'NMEMPRESA');
        // geralPage.searchAndClickGridField('CDINSCESTA', j.getValor('cdinscesta01'), 'CDINSCESTA');
        element(by.className('close zh-icon zh-icon-down')).click();
        geralPage.clickAdicionar();
        geralPage.fillField('NRINSJURAUTOXML', nrinsjurautoxml);
        geralPage.fillField('DSOBSAUTOXML', dsobsautoxml);
        geralPage.clickSalvar();
    };

    this.editarPessoaFisicaPorIE = (dsobsautoxml) => {
        element(by.className('close zh-icon zh-icon-down')).click();
        // geralPage.trocarAba('Inscrição Estadual');
        // geralPage.searchAndClickGridField('NMEMPRESA', j.getValor('unidade02'), 'NMEMPRESA');
        // geralPage.searchAndClickGridField('CDINSCESTA', j.getValor('cdinscesta01'), 'CDINSCESTA');
        geralPage.filterIt(j.getValor('dsobsautoxml03'));
        geralPage.clickGrid('DSOBSAUTOXML', j.getValor('dsobsautoxml03'), '4952023273444274517688', false);
        geralPage.clickEditar();
        geralPage.fillField('DSOBSAUTOXML', j.getValor('dsobsautoxml01'));
        geralPage.clickSalvar();
        geralPage.clickVoltar();
    };

    this.excluirPessoaFisicaPorIe = (dsobsautoxml) => {
        geralPage.trocarAba('Inscrição Estadual');
        geralPage.searchAndClickGridField('NMEMPRESA', j.getValor('unidade02'), 'NMEMPRESA');
        geralPage.searchAndClickGridField('CDINSCESTA', j.getValor('cdinscesta01'), 'CDINSCESTA');
        geralPage.clickGrid('DSOBSAUTOXML', j.getValor('dsobsautoxml03'), '4952023273444274517688', false);
        geralPage.clickExcluir();
        geralPage.clickSim();
    };

    this.replicacaoParaObterXml = () => {
        geralPage.trocarAba('Inscrição Estadual');
        z.component.footer.clickRightActionByLabel('Replicação');
        geralPage.searchAndClickGridField('NMEMPRESAORIG ', j.getValor('unidade02'), 'NMEMPRESA');
        geralPage.searchAndClickGridField('CDINSCESTAORIG', j.getValor('cdinscesta01'), 'CDINSCESTA');
        geralPage.searchAndClickGridField('NMEMPRESADEST', j.getValor('unidade01'), 'NMEMPRESA');
        geralPage.selectMultiple('CDINSCESTADEST', 'CDINSCESTA', j.getValor('cdinscesta02'));
        z.component.footer.clickRightActionByLabel('Confirmar');
        geralPage.clickSim();
        element(by.id('close-x')).click();
        geralPage.searchAndClickGridField('NMEMPRESA', j.getValor('unidade01'), 'NMEMPRESA');
        geralPage.searchAndClickGridField('CDINSCESTA', j.getValor('cdinscesta02'), 'CDINSCESTA');
    };
}
module.exports = new autorizacaoParaObterXml();
